/****************************************************************************
//   elforkane Copyright (C) 2012 yahia nouah <yahiaui@gmail.com>
//
//      This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
//      This is free software, and you are welcome to redistribute it
//      under certain conditions; type `show c' for details.
//
//  The hypothetical commands `show w' and `show c' should show the appropriate
//  parts of the General Public License.  Of course, your program's commands
//  might be different; for a GUI interface, you would use an "about box".
//
//    You should also get your employer (if you work as a programmer) or school,
//  if any, to sign a "copyright disclaimer" for the program, if necessary.
//  For more information on this, and how to apply and follow the GNU GPL, see
//  <http://www.gnu.org/licenses/>.
//
//    The GNU General Public License does not permit incorporating your program
//  into proprietary programs.  If your program is a subroutine library, you
//  may consider it more useful to permit linking proprietary applications with
//  the library.  If this is what you want to do, use the GNU Lesser General
//  Public License instead of this License.  But first, please read
//  <http://www.gnu.org/philosophy/why-not-lgpl.html>.
// ----------------------------------------------------------
** If you have questions regarding the use of this file, please contact
** yahia nouah (yahiaui@gmail.com)
** $elforkane_END_LICENSE$
**
****************************************************************************/
#include "dialogoption.h"
#include "ui_dialogoption.h"
#include <QFile>
#include <QDir>
#include <QTextStream>
#include <QMessageBox>
#include <QPainter>
#include <QColorDialog>
#include <QDebug>
#include <QFileDialog>
#include <QDesktopServices>
DialogOption::DialogOption(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::DialogOption)
{
    ui->setupUi(this);
}

DialogOption::~DialogOption()
{
    delete ui;
}


void DialogOption::on_spinBoxFrom_valueChanged(int arg1)
{
     ui->spinBoxTo->setMinimum(arg1);
}

void DialogOption::on_buttonBox_accepted()
{

    autoPlayNext=ui->radioButtonRepeatAll->isChecked();
    autoRepeatSura=  ui->radioButtonRepeatSura->isChecked();
    autoRepeatPage= ui->radioButtonRepeatPage->isChecked();
    autoRepeatOne=ui->radioButtonRepeatOne->isChecked();
    autoRepeatFromTo= ui->radioButtonFromTo->isChecked();
    numberRepeats= ui->spinBoxNumRepeat->value();
    isRepeatNumber=ui->checkBoxNumRepeat->isChecked();
    repeatAyaFirst=ui->spinBoxFrom->value();
    repeatAyaLast=ui->spinBoxTo->value();

        animEnabled= ui->checkBoxAnimEfect->isChecked();
        fitInView= ui->checkBoxFitInView->isChecked();
        minimizToTry=ui->checkBoxSystry->isChecked();
        textInIcons=ui->checkBoxtool->isChecked();
        showMediaControl=ui->checkBoxMediaControl->isChecked();
        infoDely=ui->spinBoxsystry->value();
        cadrFolder= ui->comboBoxTheme->currentText();
        showMenu=ui->checkBoxShowMenu->isChecked();
        showSelection=ui->checkBoxShowSelection->isChecked();
        reciteBasmala=ui->checkBoxReciteBasmala->isChecked();
     //  fullScreenBgr=ui->lineEditFileBgr->text();
       fullAnimated=ui->checkBoxFullType->isChecked();
fullIndex=ui->comboBoxFull->currentIndex();
if(ui->comboBoxRiwayat->count()>0)
riwayat=ui->comboBoxRiwayat->itemData(ui->comboBoxRiwayat->currentIndex()).toString();
        //    int index=ui->comboBoxLanguage->currentIndex();
        //    QVariant lngg=ui->comboBoxLanguage->itemData(index);
        //    lng=lngg.toString();

}

void DialogOption::on_comboBoxLanguage_activated(int index)
{
    QVariant lngg=ui->comboBoxLanguage->itemData(index);
    lng=lngg.toString();
    QMessageBox::information(this,"",trUtf8("The language for this application has been changed.The change will take effect the next time the application is started."));

}
//void DialogOption::setPixColor(QPushButton *btn)
//{

//    QIcon icon1;
//    QPixmap pixColor(30,16);
//     QPainter p;
//     p.begin(&pixColor);
//     QColor color=selectColor;
//     color.setAlpha(255);
//     p.fillRect(0, 0, 30, 16, color);
//     p.end();
//    icon1.addPixmap(pixColor);
//    btn->setIcon(icon1);
//}

void DialogOption::on_pushButtonColor_clicked()
{

    QColor couleur = QColorDialog::getColor(selectColor, this,trUtf8("Select Color"));
       if( couleur.isValid()){
          selectColor=couleur;
       //   setPixColor(ui->pushButtonColor);
          setSelectColor(couleur);
       }
}
//*****************
void DialogOption::setAppPath(QString path)
{
appPath=path;
    QDir dirImage(path+"/themes");
    QString subdir;
    ui->comboBoxTheme->addItem(trUtf8("default"));
    foreach ( subdir, dirImage.entryList(QDir::AllDirs | QDir::NoDotAndDotDot |
                                         QDir::Hidden )){
        QIcon icon(path+"/themes/"+subdir+"/top.png");
        ui->comboBoxTheme->addItem(icon,subdir);

    }

    QFile file;
    file.setFileName(path+"/language/launguagerc");
    ui->comboBoxLanguage->addItem(trUtf8("system"),"sys");
    if(file.open( QFile::ReadOnly)){
        QTextStream textStream(&file);
        QString line;
        line = textStream.readLine();//premier line
        while (!line.isNull()) {

            QString txt=line.section(",",0,0);
             QString txtdata=line.section(",",1,1);
            ui->comboBoxLanguage->addItem(txt,txtdata);
            line = textStream.readLine();
        }
    }else{
        qDebug()<<"no open : "+path+"/language/launguagerc";
    }
    file.close();
}

void DialogOption::setAutoPlayNext(bool playNext)
{
     ui->radioButtonRepeatAll->setChecked( playNext);
     autoPlayNext=playNext;
}

void DialogOption::setautoRepeatSura(bool repeatSura)
{
     ui->radioButtonRepeatSura->setChecked( repeatSura);
     autoRepeatSura=repeatSura;
}

void DialogOption::setAutoRepeatPage(bool repeatPage)
{
    ui->radioButtonRepeatPage->setChecked( repeatPage);
    autoRepeatPage=repeatPage;
}

void DialogOption::setAutoRepeatOne(bool repeatOne)
{
    ui->radioButtonRepeatOne->setChecked( repeatOne);
    autoRepeatOne=repeatOne;
}

void DialogOption::setAutoRepeatFromTo(bool repeatFromTo)
{
      ui->radioButtonFromTo->setChecked( repeatFromTo);
      autoRepeatFromTo=repeatFromTo;
}

void DialogOption::setRepeatNumber(bool isRepeat)
{
       ui->checkBoxNumRepeat->setChecked(isRepeat);
       isRepeatNumber=isRepeat;
}

void DialogOption::setNumberRepeats(int number)
{
     ui->spinBoxNumRepeat->setValue( number);
     numberRepeats=number;
}

void DialogOption::setRepeatAyaFirst(int number)
{
repeatAyaFirst=number;
}

void DialogOption::setRepeatAyaLast(int number)
{
repeatAyaLast=number;
}

void DialogOption::setSpinMax(int number)
{
  //  spinMax=number;
    ui->spinBoxFrom->setMaximum(number);
    ui->spinBoxTo->setMaximum(number);
    ui->spinBoxFrom->setMinimum(1);
    ui->spinBoxTo->setMinimum(1);
}

void DialogOption::setInfoDely(int number)
{
     ui->spinBoxsystry->setValue(number);
     infoDely=infoDely;
}

void DialogOption::setCurTab(int number)
{
    ui->stackedWidget->setCurrentIndex(number);

}

void DialogOption::setAnimEnabled(bool anim)
{
       ui->checkBoxAnimEfect->setChecked( anim);
       animEnabled=anim;
}

void DialogOption::setFitInView(bool fit)
{
    ui->checkBoxFitInView->setChecked( fit);
    fitInView=fit;
}

void DialogOption:: setMinimizToTry(bool minimiz)
{
     ui->checkBoxSystry->setChecked( minimiz);
     minimizToTry=minimiz;
}

void DialogOption::setTextInIcons(bool textIcons)
{
     ui->checkBoxtool->setChecked( textIcons);
     textInIcons=textIcons;
}

void DialogOption::setShowMediaControl(bool show)
{
     ui->checkBoxMediaControl->setChecked(show);
     showMediaControl=show;
}

void DialogOption::setLng(QString language)
{
    lng=language;
    int idxl=ui->comboBoxLanguage->findData(language);
    ui->comboBoxLanguage->setCurrentIndex(idxl);
}

void DialogOption::setCadrFolder(QString folder)
{
    cadrFolder=folder;
    int idx= ui->comboBoxTheme->findText(folder);
    ui->comboBoxTheme->setCurrentIndex(idx);
}
void DialogOption::setShowMenu(bool show)
{
    showMenu=show;
  ui->checkBoxShowMenu->setChecked(show);

}
void DialogOption::setShowSelection(bool show)
{
    showSelection=show;
  ui->checkBoxShowSelection->setChecked(show);

}
void DialogOption::setReciteBasmala(bool recite)
{
   reciteBasmala=recite;
   ui->checkBoxReciteBasmala->setChecked(recite);
}

void DialogOption::setSelectColor(QColor color)
{
    selectColor=color;
   //  setPixColor(ui->pushButtonColor);
     QIcon icon1;
     QPixmap pixColor(30,16);
      QPainter p;
      p.begin(&pixColor);
      //QColor color=selectColor;
      color.setAlpha(255);
      p.fillRect(0, 0, 30, 16, color);
      p.end();
     icon1.addPixmap(pixColor);
     ui->pushButtonColor->setIcon(icon1);
}

void DialogOption::setFullSceenAnimated(bool animated)
{
    ui->checkBoxFullType->setChecked(animated);

     fullAnimated=animated;

}


void DialogOption::setListFullSceen(QList<QString > listSceenName,int index)
{
    int i=listSceenName.count();
    if(i<1){
        fullAnimated=false;
        ui->checkBoxFullType->setChecked(false);
        ui->groupBox->setEnabled(false);
    }
    for(int r=0;r<i;r++){
        QString name=listSceenName.at(r);
        ui->comboBoxFull->addItem(name);

    }



    ui->comboBoxFull->setCurrentIndex(index);
}

void DialogOption::setRiwayat(QList<QString > listRiwayaText,QList<QString > listRiwayaData,QString curent)
    {
        int r=listRiwayaText.count();
        if(r<1)return;
        for(int i=0;i<r;i++){
            ui->comboBoxRiwayat->addItem(listRiwayaText.at(i),listRiwayaData.at(i));
        }
        int index=listRiwayaData.indexOf(curent);
           ui->comboBoxRiwayat->setCurrentIndex(index);
riwayat=curent;
    }
void DialogOption::on_checkBoxMediaControl_clicked()
{
    QMessageBox::information(this,"",trUtf8("The change will take effect the next time the application is started."));

}



void DialogOption::on_toolButtonFullOption_clicked()
{
  //   qDebug()<<listSceen.count();
    if(listSceen.count()<1)
        return;

    int i=ui->comboBoxFull->currentIndex();
    listSceen.at(i)->execOptions();
}
