/****************************************************************************
//   elforkane Copyright (C) 2012 yahia nouah <yahiaui@gmail.com>
//
//      This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
//      This is free software, and you are welcome to redistribute it
//      under certain conditions; type `show c' for details.
//
//  The hypothetical commands `show w' and `show c' should show the appropriate
//  parts of the General Public License.  Of course, your program's commands
//  might be different; for a GUI interface, you would use an "about box".
//
//    You should also get your employer (if you work as a programmer) or school,
//  if any, to sign a "copyright disclaimer" for the program, if necessary.
//  For more information on this, and how to apply and follow the GNU GPL, see
//  <http://www.gnu.org/licenses/>.
//
//    The GNU General Public License does not permit incorporating your program
//  into proprietary programs.  If your program is a subroutine library, you
//  may consider it more useful to permit linking proprietary applications with
//  the library.  If this is what you want to do, use the GNU Lesser General
//  Public License instead of this License.  But first, please read
//  <http://www.gnu.org/philosophy/why-not-lgpl.html>.
// ----------------------------------------------------------
** If you have questions regarding the use of this file, please contact
** yahia nouah (yahiaui@gmail.com)
** $elforkane_END_LICENSE$
**
****************************************************************************/
#ifndef DIALOGOPTION_H
#define DIALOGOPTION_H
#include "fullinterface.h"
#include <QDialog>

namespace Ui {
    class DialogOption;
}

class DialogOption : public QDialog
{
    Q_OBJECT

public:
    explicit DialogOption(QWidget *parent = 0);
    ~DialogOption();
    //reapet settings
    bool autoPlayNext;
    bool autoRepeatSura;
    bool autoRepeatPage;
    bool autoRepeatOne;
    bool autoRepeatFromTo;
    bool isRepeatNumber;
    int numberRepeats;
    int repeatAyaFirst;
    int repeatAyaLast;
    // int spinMax;
    //generale
    bool animEnabled;
    bool fitInView;
    bool minimizToTry;
    bool textInIcons;
    bool showMediaControl;
    bool showMenu;
    bool showSelection;
    bool reciteBasmala;
    int infoDely;
    QString lng;
    QString cadrFolder;
    QString appPath;
QString riwayat;
    QColor selectColor;
    int fullIndex;
    bool fullAnimated;
    QList<SceenFullInterface *>listSceen;
public slots:
    //6 void chargeSettings();
    //************
    void setAutoPlayNext(bool playNext);
    void setautoRepeatSura(bool repeatSura);
    void setAutoRepeatPage(bool repeatPage);
    void setAutoRepeatOne(bool repeatOne);
    void setAutoRepeatFromTo(bool repeatFromTo);
    void setRepeatNumber(bool isRepeat);
    void setNumberRepeats(int number);
    void setRepeatAyaFirst(int number);
    void setRepeatAyaLast(int number);
    void setSpinMax(int number);
    void setInfoDely(int number);
    void setCurTab(int number);
    void setAnimEnabled(bool anim);
    void setFitInView(bool fit);
    void setMinimizToTry(bool minimiz);
    void setTextInIcons(bool textIcons);
    void setShowMediaControl(bool show);
    void setLng(QString language);
    void setCadrFolder(QString folder);
    void setAppPath(QString path);
    void setSelectColor(QColor color);
    void setShowMenu(bool show);
    void setShowSelection(bool show);
    void setReciteBasmala(bool recite);
    void setFullSceenAnimated(bool Animated);
    void setRiwayat(QList<QString > listRiwayaText,QList<QString > listRiwayaData,QString curent);
    //void setFullBackgroundDir(QString bgr);
    void setListFullSceen(QList<QString > listSceenName, int index);
private slots:
    void on_spinBoxFrom_valueChanged(int arg1);

    void on_buttonBox_accepted();

    void on_comboBoxLanguage_activated(int index);
    //  void setPixColor(QPushButton *btn);
    void on_pushButtonColor_clicked();

    void on_checkBoxMediaControl_clicked();

    void on_toolButtonFullOption_clicked();

private:
    Ui::DialogOption *ui;
    SceenFullInterface *sceenFullInterface;

};

#endif // DIALOGOPTION_H
