/****************************************************************************
//   elforkane Copyright (C) 2012 yahia nouah <yahiaui@gmail.com>
//
//      This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
//      This is free software, and you are welcome to redistribute it
//      under certain conditions; type `show c' for details.
//
//  The hypothetical commands `show w' and `show c' should show the appropriate
//  parts of the General Public License.  Of course, your program's commands
//  might be different; for a GUI interface, you would use an "about box".
//
//    You should also get your employer (if you work as a programmer) or school,
//  if any, to sign a "copyright disclaimer" for the program, if necessary.
//  For more information on this, and how to apply and follow the GNU GPL, see
//  <http://www.gnu.org/licenses/>.
//
//    The GNU General Public License does not permit incorporating your program
//  into proprietary programs.  If your program is a subroutine library, you
//  may consider it more useful to permit linking proprietary applications with
//  the library.  If this is what you want to do, use the GNU Lesser General
//  Public License instead of this License.  But first, please read
//  <http://www.gnu.org/philosophy/why-not-lgpl.html>.
// ----------------------------------------------------------
** If you have questions regarding the use of this file, please contact
** yahia nouah (yahiaui@gmail.com)
** $elforkane_END_LICENSE$
**
****************************************************************************/
#include "mainwindow.h"
#include "ui_mainwindow.h"
//#include <stdlib.h>
#include <QtGui>
#include <QDebug>
#include "dialogaddreciter.h"
#include "dialogoption.h"
#include "dialogabout.h"
MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{

    ui->setupUi(this);
//scenfull=new ScenFull;
    database=new Database();
    QApplication::setLayoutDirection(Qt::RightToLeft);
    //تحديد مكان بيانات البرنامج حسب نوع النظام
    QDir appDir(qApp->applicationDirPath());
#if defined(Q_OS_WIN)
    m_appPath=  appDir.absolutePath()+"/elforkane";

#elif defined(Q_OS_MAC)
    if (appDir.dirName() == "MacOS") {
        appDir.cdUp();
        appDir.cdUp();
        appDir.cdUp();
        m_appPath=  appDir.absolutePath()+"/elforkane";

    }
#else
    appDir.cdUp();
    m_appPath=  appDir.absolutePath()+"/share/elforkane";
#endif
  //  qDebug()<< " application path ="+m_appPath;
    //تحميل الاعدادات الافتراضية للمتغيرات
  m_curentSafhaRight=1;   m_curentSafhaLeft=2;
    m_repeatNumber=2;
    m_isRepeatNumber=false;
    m_layouDir=trUtf8("ltr","layou direction for this language ex:rtl for arabic");
    m_y="40";
    m_difer=0;
    m_bLeft=false;
    m_bRight=false;
    m_px=457;
    m_numPlayed=1;
    m_pHieght=672;
    m_pWith=456;
    m_soundPath="audio/Husary_Mujawwad_64kbps";
    m_autoRepeatPage=false;
    m_autoRepeatOne=false;
    m_autoRepeatSura=false;
    m_autoRepeatFromTo=false;
    m_autoPlayNext=true;
    isPlay=false;
    emit popupVisible(false);
    //التحميلات والاعدادات


    loadSetting();   //تحميل ااعدادات المستخدم
 //   qDebug()<<"loadSetting";
    setupToolbarIcons();//انشاء الادوات والايقونات
 //   qDebug()<<"setupToolbarIcons";
    locateThemePath();//تحديد سمة الصفحات
 //  qDebug()<<" locatedThemePath";
    creatPagesAndPopup();//انشاء الصفحات ونافذة التفاسير

    // creatNavigation();
    if(m_showMediaControl==false)
        creatMediaControles();//انشاء نافذة الوسائط

    createTrayIcon();//انشاء ايقونة صينية النظام
    trayIcon->setVisible(m_minimizToTry);
    //تحميل البيانات

    database->chargeCsvs(m_curentRiwaya);
    database->treeChargeJozaa(ui->treeWidgetIndex);
    database->treeChargeSoura(ui->treeWidgetIndex,false,comboSura,m_layouDir,m_sura-1);

    chargeDataTools();    // تحميل  التراجم التفاسير بيانات المقرئين
    comboBoxReciter->setCurrentIndex(m_receter);
    newPages();//الانتقال الى صفحة جديدة
    //تحديد مسار الصوت الاخير
    QString txt=comboBoxReciter-> itemData(m_receter).toString();
    m_soundPath=txt.section("|",0,0);
    m_soundUrl=txt.section("|",1,1);

    m_MediaObject.setCurrentSource(m_appPath+"/audhubillah.mp3");
    m_MediaObject.play();
    m_plaOne=true;
    //الانتقال الى الموضع المحدد
    setCurentPos(m_id);
    //تحميل اول واخر اية سواء في السورة او الصفحة
   //  chargeLastAndFirstAya();
    //-------
loadPlugin();
    // actTansTefsir->setChecked(m_showPopup);

}

   MainWindow::~MainWindow()
{
    QFile fileReciter(QDir::homePath()+"/.elforkane/reciterInfo");
    if (!fileReciter.open(QFile::WriteOnly)){
          return ;
      }
    QTextStream out(&fileReciter);
    for (int i=0;i<comboBoxReciter->count();i++){
         QString txtName=comboBoxReciter->itemText(i);
         QVariant txtData=comboBoxReciter->itemData(i);

        out << txtName+","+txtData.toString()+"\n";
    }
    fileReciter.close();
    saveSetting();
      if(myListSceen.count()>0)
    sceenFullInterface->~SceenFullInterface();
        delete ui;
     delete database;
}
   void MainWindow::closeEvent(QCloseEvent *e)
   {
      m_MediaObject.stop();
   }

   void MainWindow::setupToolbarIcons()
   {
       ui->menuBar->setVisible(m_showMenu);
       ui->lineEditSearchTree->installEventFilter(this);
       ui->lineEditSearchTree->setText(trUtf8("Search"));
       ui->lineEditSearchTree->setStyleSheet("QLineEdit {font: italic;color: rgb(115, 115, 115);}");
       ui->dockWidget->setVisible(false);
       ui-> treeWidgetIndex->setColumnHidden(1,true);
       ui->treeWidgetSearch->setColumnHidden(3,true);
       ui->treeWidgetSearch->setColumnWidth(0,50);
       ui->treeWidgetSearch->setColumnWidth(1,30);
       ui->treeWidgetSearch->setColumnWidth(2,300);

       ui->actionEnableAnimFull->setChecked(m_fullAnimEnable);
   ui->actionAbout->setIcon(QIcon::fromTheme("stock_about",QIcon(style()->standardPixmap(QStyle::SP_DialogHelpButton))));
       //------------اضافة ادوات الى المشهد حتى تعمل الاختصارات عند عدم ظهور القوائم
       ui->graphicsView->addAction(ui->actionFullScreen);
       ui->graphicsView->addAction(ui->actionNextAya);
       ui->graphicsView->addAction(ui->actionPrevAya);
       ui->graphicsView->addAction(ui->actionPlayPause);
       ui->graphicsView->addAction(ui->actionNextSura);
       ui->graphicsView->addAction(ui->actionPrevSura);
       ui->graphicsView->addAction(ui->actionNextPage);
       ui->graphicsView->addAction(ui->actionPrevPage);
       ui->graphicsView->addAction(ui->actionEnableAnimFull);

       //---------toolbox style---------------------------------
       int mred= this->palette().color(QPalette::Dark).red();
       int mgreen= this->palette().color(QPalette::Dark).green();
       int mblue= this->palette().color(QPalette::Dark).blue();
       QString stylbox=QString("QToolBox::tab {"
                               "background-color: qlineargradient(spread:pad, x1:0, y1:0, x2:0, y2:1, stop:0 rgba(%1, %2, %3, 100), stop:1 rgba(255, 255, 255, 80));"
                               "border-radius: 5px;}"
                               "QToolBox::tab:hover { "
                               "background-color: qlineargradient(spread:pad, x1:0, y1:0, x2:0, y2:1, stop:0 rgba(255, 255, 255, 80), stop:1 rgba(%1, %2, %3, 200));"
                               "font: italic;  }"
                               "QToolBox::tab:selected { "
                               "background-color: qlineargradient(spread:pad, x1:0, y1:0, x2:0, y2:1, stop:0 rgba(%1, %2, %3, 250), stop:1 rgba(255, 255, 255, 0));"
                               "}").arg(QString::number(mred)).arg(QString::number(mgreen)).arg(QString::number(mblue)) ;

       ui->toolBox->setStyleSheet(stylbox);
       ui->toolBox->setCurrentIndex(1);

       if(m_textIcon==true){
           ui->toolBar->setToolButtonStyle(Qt::ToolButtonTextUnderIcon);
       }else{
           ui->toolBar->setToolButtonStyle(Qt::ToolButtonIconOnly);
       }
       connect(ui->comboBoxSoraJozaa, SIGNAL(currentIndexChanged(int)), this, SLOT(comboBoxSoraJozaa_currentIndexChanged(int)));
       connect(ui->treeWidgetIndex, SIGNAL(itemActivated(QTreeWidgetItem*,int)), this, SLOT(treeWidgetIndex_itemActivated(QTreeWidgetItem*,int)));
       connect(ui->lineEditSearchTree, SIGNAL(textChanged(QString)), this, SLOT(lineEditSearchTree_textChanged(QString)));
       connect(ui->dockWidget, SIGNAL(visibilityChanged(bool)), ui->actionNavigation, SLOT(setChecked(bool)));
       ui->menuView->addAction(ui->toolBar->toggleViewAction());
       //ui->dockWidget->toggleViewAction()->setShortcut(QKeySequence(tr("Ctrl+L")));
       ui->toolBar->toggleViewAction()->setShortcut(QKeySequence(tr("Ctrl+M")));

       // connect(ui->toolBar, SIGNAL(visibilityChanged(bool)), ui->menuBar, SLOT(setHidden(bool)));
       //----------------Phonon--------------------------------------------------------
       connect(&m_MediaObject, SIGNAL(stateChanged(Phonon::State,Phonon::State)), this, SLOT(stateChanged(Phonon::State,Phonon::State)));
       connect(&m_MediaObject, SIGNAL(finished()), this, SLOT(mediaFinished()));

       Phonon::createPath(&m_MediaObject, &m_AudioOutput);


       //-------------End--Phonon----------------------------------------------------


       //---------------setup actions
       // QLabel *labSafha=new QLabel(trUtf8("Safha"),this);
       spinSafha=new QSpinBox(this);
       connect(spinSafha, SIGNAL(editingFinished()), this, SLOT(goPage()));

       comboSura=new QComboBox(this);
       connect(comboSura, SIGNAL(activated(int)), this, SLOT(goSura(int )));
       connect(comboSura, SIGNAL(currentIndexChanged(int)), this, SLOT(setSpinAyaMaximum(int)));
       //  QLabel *labAya=new QLabel(trUtf8("Aya"),this);
       spinAya=new  QSpinBox(this);
       connect(spinAya, SIGNAL(editingFinished()), this, SLOT(goAya()));
       // QLabel *labJozaa=new QLabel(trUtf8("Jozaa"),this);
       spinJozaa=new  QSpinBox(this);
       connect(spinJozaa, SIGNAL(editingFinished()), this, SLOT(goJozaa()));
       // QLabel *labHizb=new QLabel(trUtf8("Hizb"),this);
       spinHizb=new  QSpinBox(this);
       connect(spinHizb, SIGNAL(editingFinished()), this, SLOT(goHizb()));
       spinAya->setMinimum(1);
       spinJozaa->setMinimum(1);
       spinHizb->setMinimum(1);
       spinSafha->setMinimum(1);
       spinJozaa->setMaximum(30);
       spinHizb->setMaximum(60);
       spinSafha->setMaximum(604);

       // ui->toolBar->addAction(ui->dockWidget->toggleViewAction());
       ui->toolBar->addAction(ui->actionOptions);
       ui->toolBar->addAction(ui->actionNavigation);
       ui->toolBar->addAction(ui->actionRepeatOption);
       ui->toolBar->addAction(ui->actionFullScreen);
       actTansTefsir=new QAction(QIcon(":/img/tefsir.png"),trUtf8("Translation and Tefsir"),this);
       actTansTefsir->setCheckable(true);


       connect(actTansTefsir, SIGNAL(toggled(bool)), this, SLOT(popup_toggled(bool)));
       connect(this, SIGNAL(popupVisible(bool)), actTansTefsir, SLOT(setChecked(bool)));

       ui->toolBar->addAction(actTansTefsir);
       actTansTefsir->setMenu(ui->menuTransTefsir);
       ui->toolBar->addSeparator();
       //------------------1--------------------
       // ui->toolBar->addAction(ui->actionPrevPage);
       ui->toolBar->addWidget(new QLabel(trUtf8("Page"),this)) ;
       ui->toolBar->addWidget(spinSafha);
       // ui->toolBar->addAction(ui->actionNextPage);
       ui->toolBar->addSeparator();
       //----------------2-----------------------
       //  ui->toolBar->addAction(ui->actionPrevSura);
       ui->toolBar->addWidget(comboSura);
       //   ui->toolBar->addAction(ui->actionNextSura);

       //---------------3-----------------------
       // ui->toolBar->addAction(ui->actionPrevAya);
       ui->toolBar->addWidget(new QLabel(trUtf8("Aya"),this));
       ui->toolBar->addWidget(spinAya);
       // ui->toolBar->addAction(ui->actionNextAya);

       //---------------4--------------------------
       ui->toolBar->addWidget(new QLabel(trUtf8("Jozaa"),this)) ;
       ui->toolBar->addWidget(spinJozaa);
       ui->toolBar->addWidget(new QLabel(trUtf8("Hizb"),this));
       ui->toolBar->addWidget(spinHizb);
       ui->toolBar->addSeparator();
       //-------phonon---------------
       slider = new Phonon::SeekSlider(this);
       slider->setMaximumWidth(150);
       slider->setMediaObject(&m_MediaObject);
       volume = new Phonon::VolumeSlider(&m_AudioOutput);
       volume->setMaximumWidth(100);
       if(m_showMediaControl==true){
           ui->toolBar->addWidget(slider);
           ui->toolBar->addAction(ui->actionPlayPause);
           ui->toolBar->addAction(ui->actionStopMedia);
           ui->toolBar->addWidget(volume);
       }
       //-------end phonon---------------
       //--------------------------------
       comboBoxReciter = new QComboBox(this);
       comboBoxReciter->setMaximumWidth(150);
       ui->toolBar->addWidget(comboBoxReciter);
       QMenu *menu=new QMenu(this);
       menu->addAction(ui->actionAddReceter);
       menu->addAction(ui->actionEditeReceter);
       menu->addAction(ui->actionRemoveReceter);
       ui->actionRceterEdite->setMenu(menu);
       ui->toolBar->addAction(ui->actionRceterEdite);
       connect(comboBoxReciter, SIGNAL(activated(int)), this, SLOT(comboBoxResiter_activated(int)));
       //--------------------------------
       QWidget *widget=new QWidget;
       QHBoxLayout *horizontalLayoutTool = new QHBoxLayout(widget);
       QSpacerItem *horizontalSpacer=new QSpacerItem(10, 10, QSizePolicy::Expanding, QSizePolicy::Minimum);
       horizontalLayoutTool->addItem(horizontalSpacer);
       ui->toolBar->addWidget(widget);
       ui->toolBar->addAction(ui->actionAbout);
       //------------------------------------
       panelMedia=new  QGraphicsWidget;
       QPixmap pixmy(54,24);
       pixmy.fill(Qt::transparent);
       btnMedia=new Pixmap(pixmy,panelMedia);

       playIcon=QIcon(":/img/media-playback-start.png");
       pauseIcon=QIcon(":/img/media-playback-pause.png");
       ui->actionPlayPause->setIcon(playIcon);
       //ui->dockWidget->toggleViewAction()->setIcon(QIcon(":/img/document-properties.png"));
   }

   //----------------------------انشاء الصفحات و ناقذة التفاسير والتراجم----------------------------
   void MainWindow::creatPagesAndPopup()
   {
       //انشاء اللوحة الام مع الصفحتين اليسرى واليمنى
       panelParent = new QGraphicsWidget;
       pageLeft=new QGraphicsPixmapItem(panelParent);
       pageRight=new QGraphicsPixmapItem(panelParent);
       pageLeft->setPos(0,0);
       pageRight->setPos(m_pWith,0);
       QPainter p;
       //انشاء اطار سفلي
       QPixmap pixbotum((m_pWith*2)+2,m_pHieght+2);
       pixbotum.fill(Qt::transparent);
       p.begin(&pixbotum);
       p.setPen(QColor(127,120,25,100));
       QRectF rect(1.0, 1.0, (m_pWith*2), m_pHieght);
       p.drawRect(rect);
       p.end();
       //انشاء زرين على اليمين واليسار لسحب الصفحات
       QPixmap pixT(1,1);
       pixT.fill(Qt::transparent);
       btnLeft=new Pixmap(pixT);
       btnLeft->setGeometry(QRectF(0,0,30,m_pHieght));
       connect(btnLeft, SIGNAL(enter()), this, SLOT(goNextEenter()));
       connect(btnLeft, SIGNAL(leave()), this, SLOT(goNextLeave()));
       connect(btnLeft, SIGNAL(pressed()), this, SLOT(goNextPrissed()));
       connect(btnLeft, SIGNAL(release()), this, SLOT(goNextRelease()));
       connect(btnLeft, SIGNAL(mouseMove()), this, SLOT(goNextMoved()));
       btnRight=new Pixmap(pixT);
       btnRight->setGeometry(QRectF((m_pWith*2)-30,0,30,m_pHieght));
       connect(btnRight, SIGNAL(enter()), this, SLOT(goPrevEenter()));
       connect(btnRight, SIGNAL(leave()), this, SLOT(goPrevLeave()));
       connect(btnRight, SIGNAL(pressed()), this, SLOT(goPrevPrissed()));
       connect(btnRight, SIGNAL(release()), this, SLOT(goPrevRelease()));
       connect(btnRight, SIGNAL(mouseMove()), this, SLOT(goPrevMoved()));
       //انشاء اطار لاستعماله عند تحريك الصفحات بواسطة الرسم التلقائي  من نوع لابل label
       QGraphicsProxyWidget *maskProxy = new QGraphicsProxyWidget;
       m_labMask=new QLabel();
       m_labMask->setGeometry(0,0,150,m_pHieght);
       maskProxy->setWidget(m_labMask);
       //انشاء اطار التحديد بابعاد اافتراضية
       itemSelection = new Pixmap( updatePixSelect(60,382,382));
        itemSelection->setGeometry(QRectF(m_px+37,40,382,60));
       //انشاء اطار للظل المتحرك اثناء تحريك الصفحات اليمنى واليسرى
       QPixmap pixsRefletLeft(60,m_pHieght);
       pixsRefletLeft.fill(Qt::transparent);
       p.begin(&pixsRefletLeft);
       p.drawPixmap(0,0,80,m_pHieght,QPixmap(":/img/reflet.png"));
       p.end();
       itemRefletLeft= new Pixmap(pixsRefletLeft);
       itemRefletLeft->setGeometry(QRectF(0,1,80,m_pHieght));

       QPixmap pixsRefletRight(80,m_pHieght);
       pixsRefletRight.fill(Qt::transparent);
       p.begin(&pixsRefletRight);
       p.drawPixmap(0,0,80,m_pHieght,QPixmap(":/img/refletRight.png"));
       p.end();
       itemRefletRigt= new Pixmap(pixsRefletRight);
       itemRefletRigt->setGeometry(QRectF(m_pWith-80,1,60,m_pHieght));
       //انشاء اطار للرسم عليه اثناء حركة السحب بواسطة الماوس
       picMoved=new QGraphicsPixmapItem(panelParent);

       //انشاء نافذة التفاسير والتراجم
    //قاعدة النافذة
       panelPopup=new  QGraphicsWidget;
       panelPopup->setZValue(99);
       ItemPopup= new   QGraphicsPixmapItem (panelPopup);
     //اداة النص الذي يعرض عليه التفسير والترجمة
       textEdit=new QTextEdit();
       connect(ui->actionZoomIn, SIGNAL(triggered()), textEdit, SLOT(zoomIn()));
       connect(ui->actionZoomOut, SIGNAL(triggered()), textEdit, SLOT(zoomOut()));
           textEdit->setFrameShape(QFrame::NoFrame);
       QGraphicsProxyWidget *txtProxy = new QGraphicsProxyWidget();
       QGraphicsProxyWidget *toolProxy = new QGraphicsProxyWidget();
       txtProxy->setWidget(textEdit);
       //لوحة الادوات التي تحتوي زر التكبير والتصغير وعنوان التفسير وقائمة االتبديل بين التفاسير والتراجم
       QToolBar *toolbar=new QToolBar();
       toolbar->setIconSize(QSize(16,16));
       QHBoxLayout  *horizontalLayout = new QHBoxLayout();
       QFrame *frame=new QFrame;
       horizontalLayout->setContentsMargins(1,1,1,1);
       horizontalLayout->addWidget(toolbar);
       frame->setLayout(horizontalLayout);
       QAction *actHidPop=new QAction(QIcon(":/img/list-remove.png"),trUtf8("&Hide"),frame);
       connect(actHidPop, SIGNAL(triggered()), this, SLOT(hidePopup()));
   //اضافة الادوات الى اللوحة
       toolbar->addAction(actHidPop);
       toolbar->addSeparator();
       toolbar->addAction(ui->actionZoomIn);
       toolbar->addAction(ui->actionZoomOut);
       toolbar->addSeparator();
       labelTransTefsir=new QLabel;
       labelTransTefsir->setMaximumWidth(150);
       toolbar->addWidget(labelTransTefsir);
       QString labStyle="QLabel { font: bold;color: black;}";
       labelTransTefsir->setStyleSheet(labStyle);
       QToolButton *tbtnMenu=new QToolButton(frame);
       tbtnMenu->setArrowType(Qt::DownArrow);
       connect(tbtnMenu, SIGNAL(pressed()), this, SLOT(menuTefsirAndTranslation()));
       toolbar->addWidget(tbtnMenu);
       //استخدام سمة للوحة الادوات
       QString str="QFrame ,QToolBar {"
               "background-color: rgba(255, 255, 255, 0);border: 0px}";
       frame->setStyleSheet(str);
       frame->setFrameShape(QFrame::NoFrame);
       frame->setLineWidth(0);
       toolbar->setFloatable(false);
       toolbar->setMovable(false);
       toolProxy->setWidget(frame);
       //--------------
       //اظافة الادوات والاطارات السابقة الى قاعدة النافذة
       panelPopup->setGeometry(0,0,m_pWith,(m_pHieght/2)+120);
       QGraphicsGridLayout *gridLayout = new QGraphicsGridLayout();
       gridLayout->addItem(toolProxy,0,1,Qt::AlignCenter);
       gridLayout->addItem(txtProxy,1,1,Qt::AlignCenter);
       gridLayout->setContentsMargins(70,70,70,70);
       panelPopup->setLayout(gridLayout);

       m_labMask->setVisible(false);
       itemRefletLeft->setVisible(false);
       itemRefletRigt->setVisible(false);
       panelPopup->setVisible(m_showPopup);
       emit popupVisible(m_showPopup);
     //اعداد المشهد واضافة كل الصفحات والادوات السابقة
       m_scene=new QGraphicsScene();

       m_scene->addItem(panelParent);
       m_scene->addPixmap(pixbotum);
       m_scene->addItem(itemSelection);
       m_scene->addItem(maskProxy);
       m_scene->addItem(itemRefletLeft);
       m_scene->addItem(itemRefletRigt);
       m_scene->addItem(btnLeft);
       m_scene->addItem(btnRight);
       m_scene->addItem(panelPopup);
       ui->graphicsView->setScene(m_scene);
       panelParent->setPos(0,1);
   }

void MainWindow::chargeDataTools()
{
    QFile file;
    //تحميل  التراجم --------------------------------------------
  file.setFileName(m_appPath+"/translat/translatInfo");
  if(file.open( QFile::ReadOnly)){
      QTextStream textStream(&file);
      QString line;
      line = textStream.readLine();//premier line

      QActionGroup *actTransGroup=new QActionGroup(this);
      while (!line.isNull()) {
          QString txtdata=line.section(",",0,0);
          QString txt=line.section(",",1,1);
          //comboTrans->addItem(txt,txtdata);
          QAction *act=new QAction(txt,this);
          act->setData(txtdata);
          act->setCheckable(true);
          connect(act, SIGNAL(triggered()), this, SLOT(translationChanged()));
          myListActionTrans.append(act);
          actTransGroup->addAction(act);

          line = textStream.readLine();
      }
      if (myListActionTrans.count()>=m_curTranslation){
          myListActionTrans.at(m_curTranslation)->setChecked(true);
          QVariant data=  myListActionTrans.at(m_curTranslation)->data();
          QString txt=  myListActionTrans.at(m_curTranslation)->text();
          database->openDb(m_appPath+"/translat/"+data.toString());
          convertTextToHtm(database->getTranslation(m_id));
          labelTransTefsir->setText(txt);
          isTefsirPopup=false;
      }

      ui->menuTranslation->addActions(myListActionTrans);
  }

  file.close();
       //-تحميل التفاسير
  file.setFileName(m_appPath+"/tafasir/tafasirInfo");
  if(file.open( QFile::ReadOnly)){
      QTextStream textStream(&file);
      QString line;
      QList<QAction *>myListActionTefsir;
      QActionGroup *actTefsirGroup=new QActionGroup(this);
      line = textStream.readLine();//premier line
      while (!line.isNull()) {
          QString txtdata=line.section(",",0,0);
          QString txt=line.section(",",1,1);
          QAction *act=new QAction(txt,this);
          act->setData(txtdata);
          act->setCheckable(true);
          connect(act, SIGNAL(triggered()), this, SLOT(tefsirChanged()));

          myListActionTefsir.append(act);
          actTefsirGroup->addAction(act);

          line = textStream.readLine();
      }

      ui->menuTefsir->addActions(myListActionTefsir);
  }
  file.close();
     //تحميل بيانات المقرئين------------------------------------------------------------
  file.setFileName(QDir::homePath()+"/.elforkane/reciterInfo");

  if(file.open( QFile::ReadOnly)){

      QTextStream textStream(&file);
      QString line;
      line = textStream.readLine();//premier line

      while (!line.isNull()) {
//QMessageBox::information(0,"",line);
          QString txt=line.section(",",0,0);
           QString txtdata=line.section(",",1,1);
          comboBoxReciter->addItem(txt.trimmed(),txtdata.trimmed());

          line = textStream.readLine();
      }
  }
  file.close();

}

//انشاء نافذة الوسائط المتحركة
void MainWindow::creatMediaControles()
{

   // QGraphicsPixmapItem *ItemMedia2= new   QGraphicsPixmapItem (panelMedia);
   QGraphicsPixmapItem *ItemMedia= new   QGraphicsPixmapItem (panelMedia);
   QPixmap pixmap(m_pWith,80);
   pixmap.fill(Qt::transparent);
   //qreal rad =20;
   QPainter p;
   p.begin(&pixmap);
   p.setRenderHint(QPainter::Antialiasing,true);
   p.setPen(QColor(255, 255, 255,255));
   QRectF rect(0.0,0.0,300,50.0);
   p.setBrush(QColor(255, 255, 255, 100));
   QRectF rectangle(120, 5.5, 60.0, 60.0);
   int startAngle = 16 * 210;
   int spanAngle = 16 * 120;
   p.drawRoundedRect(rect,9.0,9.0);
   p.drawChord(rectangle, startAngle, spanAngle);

   p.end();

   ItemMedia->setPixmap(pixmap);
   // ItemMedia2->setPixmap(pixmap);
   panelMedia->setGeometry(m_pWith-150,(ui->graphicsView-> height()-m_pHieght)-10,300,70);
   QGraphicsDropShadowEffect *efet=new QGraphicsDropShadowEffect;
   efet->setOffset(5,5);
   efet->setColor((QColor(63, 63, 63,200)))  ;
   efet->setBlurRadius(15);

   panelMedia->setGraphicsEffect(efet);
   QGraphicsProxyWidget *txtProxy = new QGraphicsProxyWidget();
   QToolBar *toolbar=new QToolBar();
   QHBoxLayout  *horizontalLayout = new QHBoxLayout();
   QFrame *frame=new QFrame;
   horizontalLayout->setContentsMargins(1,1,1,1);
   horizontalLayout->addWidget(toolbar);
   frame->setLayout(horizontalLayout);


   //---

   toolbar->addWidget(slider);
   toolbar->addAction(ui->actionPlayPause);
   toolbar->addAction(ui->actionStopMedia);
   toolbar->addWidget(volume);
   //  toolbar->addSeparator();
   //--------
   QString str="QFrame ,QToolBar {"
           "background-color: rgba(255, 255, 255,0);border: 0px}";
   frame->setStyleSheet(str);
   frame->setFrameShape(QFrame::NoFrame);
   frame->setLineWidth(0);
   toolbar->setFloatable(false);
   toolbar->setMovable(false);

   txtProxy->setWidget(frame);

   QGraphicsGridLayout *gridLayout = new QGraphicsGridLayout();
   gridLayout->addItem(txtProxy,1,1,Qt::AlignCenter);
   gridLayout->setContentsMargins(5,10,5,25);

   connect(btnMedia, SIGNAL(release()), this, SLOT(moveMediaControle()));
   btnMedia->setGeometry(QRectF(126,50,54,24));
   btnMedia->setCursor(Qt::PointingHandCursor);
   //   gridLayout->addItem(btnMedia,2, 1,Qt::AlignCenter);
   panelMedia->setLayout(gridLayout);
   panelMedia->setPos(m_pWith-150,-10);

   m_scene->addItem(panelMedia);
   panelMedia->resize(panelMedia->size());
}

void MainWindow::menuTefsirAndTranslation()
{
    QMenu menu(this);
    menu.addMenu(ui->menuTranslation);
    menu.addMenu(ui->menuTefsir);

   menu.addAction(ui->actionQuranText);
    menu.exec(QCursor::pos());
}

void MainWindow::resizeEvent ( QResizeEvent *  )
   {
       int ytop=(ui->graphicsView->height()-m_pHieght)/2;
       if  (m_fitInView==true)
       ui->graphicsView->fitInView(QRect(0,0,m_pWith*2,m_pHieght),Qt::KeepAspectRatio);

       if(ui->graphicsView->height()>m_pHieght||this->isFullScreen()||this->isMaximized()){
          //   int x=(ui->graphicsView->height()-m_pHieght)/2;
           panelMedia->setPos(m_pWith-150,-(ytop+50));

       }else{
            panelMedia->setPos(m_pWith-150,-50);
       }

      }

void MainWindow::changeEvent(QEvent *e)
    {
        QMainWindow::changeEvent(e);
        switch (e->type()) {

        case QEvent::LanguageChange:
            ui->retranslateUi(this);
            if(m_layouDir=="ltr"){
                QApplication::setLayoutDirection(Qt::LeftToRight);
            }else{
                  QApplication::setLayoutDirection(Qt::RightToLeft);
                  //ui->toolBox->setLayoutDirection(Qt::RightToLeft);
            }
             //  qDebug()<<m_layouDir;
            break;
        case QEvent::WindowStateChange:
            if(this->isFullScreen()){
                int x=(ui->graphicsView->height()-m_pHieght)/2+50;
                panelMedia->setPos(m_pWith-150,-x);

            }
            if(this->isMinimized()){
                if(m_minimizToTry==true)
             this->hide();
            }
         //   this->resize(this->size());
         break;


        default:
            break;
        }
    }
//---------------save and load settings--------------------------
    void MainWindow::loadSetting()
    {
        QSettings settings(QDir::homePath()+"/.elforkane/setting.ini",QSettings::IniFormat);

        settings.beginGroup("Main");
        m_id=settings.value("id",1).toInt();
        m_fitInView=  settings.value("fitInView", false).toBool();
        m_animEnabled=  settings.value("animEnabled", true).toBool();
        m_themeFolder=  settings.value("cadrFolder", trUtf8("default")).toString();
        m_showPopup=  settings.value("showPopup", false).toBool();
        m_receter=  settings.value("receter", 0).toInt();
        m_showInfo=  settings.value("showInfo",true).toBool();
        m_minimizToTry=  settings.value("minimizToTry",false).toBool();
        m_lng= settings.value("lng","sys").toString();
        m_textIcon=  settings.value("textIcon",false).toBool();
        m_infoDely=settings.value("infoDely",5).toInt();
        m_selectColor=settings.value("selectColor",QColor(127,120,25)).value<QColor>();
        m_showMediaControl=settings.value("showMediaControl",false).toBool();
         m_curTranslation=settings.value("curTranslation",0).toInt();
         m_showMenu= settings.value("showMenu",false).toBool();
          m_showSelection= settings.value("showSelection",true).toBool();
          m_reciteBasmala= settings.value("reciteBasmala",true).toBool();
          m_fullAnimEnable= settings.value("fullAnimEnable",true).toBool();
   //       m_fullScreenBgr=  settings.value("bgrFullScreen", m_appPath+"/fullscreen/bgrFull.png").toString();
          m_fullAnimated= settings.value("fullAnimated",false).toBool();
m_fullIndex= settings.value("fullIndex",0).toInt();
m_curentRiwaya= settings.value("curentRiwaya","hafs").toString();

          settings.endGroup();
     //  التحقق من المجلدات الصور في حالة تم حذفها او تغيرت الاعدادات او تشغيل البرنامج لاول مرة
QDir dir;
          if(!dir.exists(m_appPath+"/images/"+m_curentRiwaya)){
              if(dir.exists(m_appPath+"/images/hafs")){
                  m_curentRiwaya="hafs";
              }else if  (dir.exists(m_appPath+"/images/hafs-colors")){
                  m_curentRiwaya="hafs-colors";
              }else if(dir.exists(m_appPath+"/images/warsh")){
                  m_curentRiwaya="warsh";
              }else  if(dir.exists(m_appPath+"/images/warsh-colors")){
                  m_curentRiwaya="warsh-colors";
              }
          }
    }

    void MainWindow::saveSetting()
    {
        QSettings settings(QDir::homePath()+"/.elforkane/setting.ini",QSettings::IniFormat);

        settings.beginGroup("Main");
        settings.setValue("id", m_id);
        settings.setValue("fitInView", m_fitInView);
        settings.setValue("animEnabled", m_animEnabled);
        settings.setValue("cadrFolder", m_themeFolder);
        settings.setValue("showPopup", m_showPopup);
        settings.setValue("receter", m_receter);
        settings.setValue("showInfo", m_showInfo);
        settings.setValue("minimizToTry", m_minimizToTry);
        settings.setValue("lng", m_lng);
        settings.setValue("textIcon", m_textIcon);
        settings.setValue("infoDely", m_infoDely);
        settings.setValue("selectColor", m_selectColor);
        settings.setValue("showMediaControl", m_showMediaControl);
        settings.setValue("curTranslation", m_curTranslation);
        settings.setValue("showMenu", m_showMenu);
        settings.setValue("showSelection", m_showSelection);
        settings.setValue("reciteBasmala", m_reciteBasmala);
        settings.setValue("fullAnimEnable", m_fullAnimEnable);
     //   settings.setValue("bgrFullScreen", m_fullScreenBgr);
        settings.setValue("fullAnimated", m_fullAnimated);
  settings.setValue("fullIndex", m_fullIndex);
  settings.setValue("curentRiwaya", m_curentRiwaya);
        settings.endGroup();

    }
    //----systry---
    void MainWindow::createTrayIcon()
    {
        actionMinimiz=new QAction(trUtf8("&Minimize"),this);
        actionRestore=new QAction(trUtf8("&Restore"),this);
        connect(actionRestore, SIGNAL(triggered()), this, SLOT(showNormal()));
        connect(actionMinimiz, SIGNAL(triggered()), this, SLOT(showMinimized()));
        actionSowInfo=new QAction(trUtf8("&Show info"),this);
        actionSowInfo->setCheckable(true);
        actionSowInfo->setChecked(m_showInfo);
        connect(actionSowInfo, SIGNAL(toggled(bool)), this, SLOT(setshowInfo(bool)));
        QMenu *trayIconMenu = new QMenu(this);
        trayIconMenu->addAction(ui->actionPlayPause);
        trayIconMenu->addAction(ui->actionStopMedia);
        trayIconMenu->addSeparator();
        trayIconMenu->addAction(actionSowInfo);
        trayIconMenu->addAction(actionMinimiz);
        trayIconMenu->addAction(actionRestore);
        trayIconMenu->addSeparator();
        trayIconMenu->addAction(ui->actionQuit);

        trayIcon = new QSystemTrayIcon(this);
        connect(trayIcon, SIGNAL(activated(QSystemTrayIcon::ActivationReason)),
                this, SLOT(iconActivated(QSystemTrayIcon::ActivationReason)));

        trayIcon->setIcon(QIcon(":/img/mashaf48"));
        trayIcon->setContextMenu(trayIconMenu);
    }

  void MainWindow::setshowInfo(bool show)
  {
      m_showInfo=show;
  }

    void MainWindow::iconActivated(QSystemTrayIcon::ActivationReason reason)
    {
        switch (reason) {
        case QSystemTrayIcon::Trigger:
            showMessage();
      break;
        case QSystemTrayIcon::DoubleClick:
                 this->showNormal();
            break;
        case QSystemTrayIcon::MiddleClick:
      break;
        default:
            ;
        }
    }

    void MainWindow::showMessage()
    {

        if(!this->isMinimized())
            return;
        if(m_showInfo==false)
            return;

        QSystemTrayIcon::MessageIcon icon = QSystemTrayIcon::MessageIcon(QSystemTrayIcon::Information);
        QString txtTrans="";
        if(m_showPopup==true)
     txtTrans=textEdit->toPlainText();
    trayIcon->showMessage(trUtf8("Sura :")+comboSura->currentText(), trUtf8(" Aya :")
                          +QString::number(m_aya)+trUtf8(" Hizb :")+QString::number(m_hizb)+"\n"+txtTrans, icon,
                             m_infoDely * 1000);
    }


//تحريك نافذة ادولت الوسائط
void MainWindow:: moveMediaControle()
{
    int ptop=0;
    if(ui->graphicsView->height()>m_pHieght||this->isFullScreen())
        ptop=(ui->graphicsView->height()-m_pHieght)/2;

   int y=panelMedia->pos().y();

   // qDebug()<<y;
    int x=m_pWith-150;
      if (m_animEnabled==false){//اذا كانت المؤثرات الحركية غير مفعلة
           if (y<=-50){
               panelMedia->setPos(QPointF(x, -(ptop+10)));

           }else{
                panelMedia->setPos(QPointF(x, -(ptop+50)));
           }
           return;
      }

    QPropertyAnimation * anim = new QPropertyAnimation(panelMedia, "pos");
    if (y<=-50){//التحريك للاعلى

        anim->setStartValue(QPointF(x, -(ptop+50)));
        anim->setEndValue(QPointF(x, -(ptop+10)));
        anim->setEasingCurve(QEasingCurve::OutBounce);
    }else{//التحريك للاسفل

        anim->setStartValue(QPointF(x,- (ptop+10)));
            anim->setEndValue(QPointF(x, -(ptop+50)));
        anim->setEasingCurve(QEasingCurve::InCubic);
    }
    anim->setDuration(750);
    anim->start();
}

//--اعادة رسم وتحديث نافذة التراجم والتفاسير في الموضع المحدد--------------------------------
  void MainWindow::updatPopup(qreal poY,qreal poX1,qreal poX2)
  {
      qreal poY2=poY;
      if (poY2<80)
          poY2=80;
      if (poY2>m_pHieght-80)//اذا كان الموضع ع اكبر من طول الصفحة
          poY2=m_pHieght-80;

      if(isTefsirPopup==true){
          //اذا كانت تحتوي على تفسير سيكون الحجم على حجم الصفحة
          panelPopup->setGeometry(panelPopup->pos().x(),panelPopup->pos().y(),m_pWith,(m_pHieght));

      }else{
          panelPopup->setGeometry(panelPopup->pos().x(),panelPopup->pos().y(),m_pWith,(m_pHieght/2)+120);
          if (poY2>(m_pHieght/2)){
              int y=(m_pHieght/2)-120;
              panelPopup->setPos(panelPopup->pos().x(),y);
              poY2=poY2-y;
              poY=poY-y;
          }
      }

      QPainter p;
      textEdit->setStyleSheet("QTextEdit{background-color: rgba(255, 255, 255, 20);"
                              " background-attachment: fixed;}");
      QPixmap pixmap(panelPopup->geometry().width(),panelPopup->geometry().height());
      pixmap.fill(Qt::transparent);
      p.begin(&pixmap);
      p.setRenderHint(QPainter::Antialiasing,true);
      p.setPen(QColor(255, 255, 255,255));
      //ابعاد المربع
      QRectF rect(60.0,60.0,panelPopup->geometry().width()-120,panelPopup->geometry().height()-120);
      p.setBrush(QColor(255, 255, 255,180));
      //النقاط الثلاثة للمثلث
      QPointF points[3]={
          QPointF(poX1-60,poY2-10.0),
          QPointF(poX2,poY),
          QPointF(poX1-60,poY2+10.0),
      };
      //رسم المربع
      p.drawRoundedRect(rect,9.0,9.0);
      //رسم مثلث الذي يشير الى الاية
      p.drawPolygon(points,3);
      p.end();
      ItemPopup->setPixmap(pixmap);
      //اضافة مؤثر الظل الى النافذة
      QGraphicsDropShadowEffect *efet=new QGraphicsDropShadowEffect;
      efet->setOffset(5,5);
      efet->setColor((QColor(63, 63, 63,200)))  ;
      efet->setBlurRadius(15);

      ItemPopup->setGraphicsEffect(efet);

  }

void MainWindow::convertTextToHtm(QString text)
{
    text=text.replace("\\r\\n","");
    QString aya=QString::number(m_aya)+ " - ";
    QString textTrans=QString("< font color='red' >%1</font>< font color='blue' >%2</font> ").arg(aya).arg(text);
    textEdit->setHtml(textTrans);
      if(myListSceen.count()>0){
    if(m_fullAnimated==true&&this->isFullScreen())
        sceenFullInterface->setInfo(trUtf8("Sura : ")+comboSura->currentText(),
                                    trUtf8("   Jozaa : ")+QString::number(m_jozaa),
                                    trUtf8("   Hizb : ")+QString::number(m_hizb),
                                    trUtf8("   Robaa : ")+QString::number(m_robaa),
                                    trUtf8("   Aya : ")+QString::number(m_aya),
                                    trUtf8("     El Chiekh : ")+comboBoxReciter->currentText(),
                                    textEdit->toPlainText());
}
}


     //التحقق من مسارات الصور للسمة ان كانت موجودة
void MainWindow::locateThemePath()
{

    QString imgPath=m_appPath+"/themes/"+m_themeFolder;

        QFile file;
    if (!file.exists(imgPath+"/top.png") || !file.exists(imgPath+"/top_right.png")||!file.exists(imgPath+"/left.png")||
            !file.exists(imgPath+"/right.png")||!file.exists(imgPath+"/bot.png")||!file.exists(imgPath+"/bot_right.png")||
            !file.exists(imgPath+"/top_left.png")||!file.exists(imgPath+"/bot_left.png"))  {

        m_themeFolder=trUtf8("default");
        imgPath=":/images/image";
    }

}


    //الانتقال الى الموضع المحدد
    //! [1]
void MainWindow::setCurentPos(int pos)
{
    if (pos>6236||pos<1)//اذا كان الموضع اقل من 1 او اكبر من عدد الايات
        return;
    //جلب بيانات الموضع الحالي والذي يسبقه
    QString txtPrev=    database->myList->at(pos-1);
    QString txt=    database->myList->at(pos);
    //تقسيم النص لجلب البيانات
    m_id=txt.section(",",0,0).trimmed().toInt();
    int surat=txt.section(",",1,1).trimmed().toInt();
    m_aya=txt.section(",",2,2).trimmed().toInt();
    QString safha=txt.section(",",3,3).trimmed();
QString xCurent=txt.section(",",4,4).trimmed();
    m_y=txt.section(",",5,5).trimmed();
    m_jozaa=txt.section(",",6,6).trimmed().toInt();
    m_hizb=txt.section(",",7,7).trimmed().toInt();
    m_robaa=txt.section(",",8,8).trimmed().toInt();

    QString aya="000"+QString::number(m_aya);
    QString sura="000"+QString::number(surat);;
    m_soundName=sura.right(3)+aya.right(3) +".mp3";
    //   معرفة احداثيات س و ع السابقة
    QString xPrev=txtPrev.section(",",4,4).trimmed();
    QString sFirst=txtPrev.section(",",3,3).trimmed();
    QString yFirst=txtPrev.section(",",5,5).trimmed();

//اذا تغيرت الصفحة وكان اعداد تكرار الصفحة مفعل سيجلب اول اية واخرها في الصفحة
    if (m_curentSafha!=safha.toInt()){
        m_curentSafha=safha.toInt();

        if(m_autoRepeatPage==true)
            chargeLastAndFirstAya();
    }
    //اذا تغيرت السورة وكان خيار تكرار السورة سجلب بيان اول واخر اية في السورة
    if(m_sura!=surat){
        m_sura=surat;
        if(m_autoRepeatSura==true)
            chargeLastAndFirstAya();
    }
//معرفة اذا كان العدد زوجي او فردي
    int d=(safha.toInt());
    int i=fmod(d,2);
    if (safha.toInt() >m_curentSafhaLeft){//اذا كانت الصفحة المطلوبة اكبر من الصفحة الحالية اليسرى
        if (i==1){
            m_curentSafhaRight=safha.toInt();
            m_curentSafhaLeft=(safha.toInt()+1);
        }else{
            m_curentSafhaRight=(safha.toInt()-1);
            m_curentSafhaLeft=safha.toInt();
        }
        itemSelection->setVisible(false);
        panelPopup->setVisible(false);
        animPageRight();
    }else if(safha.toInt()<m_curentSafhaRight){//اذا كانت الصفحة المطلوبة اقل من الصفحة الحالية اليمنى
        m_curentSafhaRight=(safha.toInt()-1);
        m_curentSafhaLeft=safha.toInt();
        if (i==1){
            m_curentSafhaRight=safha.toInt();
            m_curentSafhaLeft=(safha.toInt()+1);
        }else{
            m_curentSafhaRight=(safha.toInt()-1);
            m_curentSafhaLeft=safha.toInt();
        }
        itemSelection->setVisible(false);
        panelPopup->setVisible(false);
        animPageLeft();

    }


    if (i==1){//اذا كانت الصفحة تحمل رقما فرديا يتم رسم نافذة التفاسير على اليمين
        m_px=457;
        panelPopup->setPos(0,0);
        updatPopup(m_y.toInt(),m_pWith,m_pWith);
    }else{
        m_px=0;
        panelPopup->setPos(457,0);
        updatPopup(m_y.toInt(),120,0);
    }
    //اذا كانت الصفحة المطلوبة لا تساوي الحالية ستكون ع =60لانها صفحة جديدة
    if(sFirst!=safha){
        yFirst="60";
        xPrev="430";
    }
    int high=m_y.toInt()-yFirst.toInt();
    int top=m_y.toInt()-high;


    if(m_showPopup==true)//اذا كان عرض التفاسير والتراجم مفعل
        convertTextToHtm(database->getTranslation(m_id));
    //نقل التحديد الى الموضع الجديد
    moveSelection(top-20,high+40,xCurent.toInt()-8,xPrev.toInt()-8);

//تحديد الموضع الحالي في الفهرسة
    QVariant dd=m_id;
    QTreeWidgetItem *item=new QTreeWidgetItem;
    QList<QTreeWidgetItem *> found =ui->treeWidgetIndex->findItems( dd.toString(),Qt::MatchExactly | Qt::MatchRecursive,1);
        foreach (item, found){
       ui-> treeWidgetIndex->setCurrentItem(item);
    }
    //-----------تحديث بيانات الادوات
    comboSura->setCurrentIndex(m_sura-1);
    spinAya->setValue(m_aya);
    spinJozaa->setValue(m_jozaa);
    spinHizb->setValue(m_hizb);
    spinSafha->setValue(m_curentSafha);
    qDebug()<<QString("-------------- pos %1-------------").arg(QString::number(m_id));
    qDebug()<<"jozaa =" +QString::number(m_jozaa);
    qDebug()<<"hizb =" +QString::number(m_hizb);
    qDebug()<<"robaa =" +QString::number(m_robaa);
    qDebug()<<"sura =" +QString::number(m_sura);
    qDebug()<<"aya =" +QString::number(m_aya);
    qDebug()<<"id =" +QString::number(m_id);
    qDebug()<<"curentSafha =" +QString::number(m_curentSafha);
    qDebug()<<"curentSafhaLeft =" +QString::number(m_curentSafhaLeft);
    qDebug()<<"curentSafhaRight =" +QString::number(m_curentSafhaRight);
    qDebug()<<"soundName =" +(m_soundName);
    qDebug()<<"soundPath =" +(m_soundPath);
     qDebug()<<"soundUrl =" +(m_soundUrl);
qDebug()<<item->text(0);
    showMessage();//عرض التنبيه قرب الساعة اذا كان محدد
}
    //! [2]
void MainWindow::moveSelection(int top,int hight,int x1,int x2)
{
    if(this->isFullScreen()){
         if(myListSceen.count()>0)
        fullScreenPixmap(top,hight,x1,x2);
    }
    if(m_autoRepeatOne==false){     //اذا كان وضع القراءة وتم تحريك التحديد
        if(isPlay==true){
            mediaPlay();
        }
    }
    //اعادة رسم التحديد


    itemSelection->setPixmap( updatePixSelect(hight,x1,x2));

    if(m_showSelection==false){      //اذا كان التحديد غير مفعل
        if (m_animEnabled==false){      //اذا لم تكن المؤثرات الحركية مفعلة
            itemSelection->setGeometry(QRect(m_px+x1-4, m_y.toInt()-12,24,26));
        }else{
            QPropertyAnimation * anim = new QPropertyAnimation(itemSelection, "geometry");
            anim->setEasingCurve(QEasingCurve::OutQuad);
            anim->setEndValue(QRect(m_px+x1-4, m_y.toInt()-12,24,26));
            anim->setDuration(550);
            anim->start();
        }
        return;
    }

    if (m_animEnabled==false){      //اذا لم تكن المؤثرات الحركية مفعلة
        itemSelection->setGeometry(QRect(m_px+37, top,382,hight));
        return;
    }
    // المؤثر الحركي لانتقال التحديد
    QPropertyAnimation * anim = new QPropertyAnimation(itemSelection, "geometry");
    anim->setEasingCurve(QEasingCurve::OutQuad);
    anim->setEndValue(QRect(m_px+37, top,382,hight));
    anim->setDuration(550);
    anim->start();

}

//--------------------
    //! [2]
QPixmap MainWindow::updatePixSelect(int h,int x1 ,int x2)
{
    QPainter p;


    if(m_showSelection==false){//اذا كان التحديد غير مفعل سيتم رسم دائرة حول رقم الاية
        QPixmap pix(24,26);
        pix.fill(Qt::transparent);
        p.begin(&pix);
        p.setRenderHint(QPainter::Antialiasing,true);
        m_selectColor.setAlpha(60);
        p.setPen(m_selectColor);
        //    QRectF rect(0.0,0.0,300,50.0);
        p.setBrush(m_selectColor);
        //   m_selectColor.setAlpha(100);
        p.drawEllipse(QRect(0, 0,24,26));
        p.end();
        return pix;
    }

    m_selectColor.setAlpha(50);
    QPixmap pixselect(384,h);
    pixselect.fill(Qt::transparent);
    p.begin(&pixselect);

    int top=0;

    //اذا كان ترقيم الاية في اخر السطر تأخذ القيمة 0 حتى لايتم رسمها
    //qDebug()<<"this x2  : "+QString::number(x2);
    if(x2<60){
        x2=0;

    }
    p.setPen(m_selectColor);
    //اذا كلنت الاية تتكون من سطر واحد اي طول اتحديد اقل من 40
    //  qDebug()<<"this hight  : "+QString::number(h);
    if (h<=40){
   //     qDebug()<<"this hight  : "+QString::number(h);
      //   qDebug()<<"this x1  : "+QString::number(x1);
       //  qDebug()<<"this x2  : "+QString::number(x2);
        p.fillRect(x1-40,top,x2-x1,40,m_selectColor);
        p.end();
        return pixselect;
    }
    //اذا كانت الاية تتكون من سطرين

    if(h<=85){


        p.fillRect(0,top,x2-40,40,m_selectColor);
        p.fillRect(x1-40,top+40,382-x1+40,40,m_selectColor);
        p.end();
        return pixselect;
    }
    //اكثر من سطرين
    p.fillRect(0,top,-40+x2,40,m_selectColor);
     p.fillRect(0,40,382,h-80,m_selectColor);
    p.fillRect(x1-40,h-40,382-x1+40,40,m_selectColor);

    p.end();

    return pixselect;
}
//---------------------
    //! [2]
void MainWindow::fullScreenPixmap(int top,int high,int x1,int x2)
{
    QPixmap pix(m_appPath+"/images/"+m_curentRiwaya+"/"+QString::number(m_curentSafha)+".png");//الصفحة التي يتم الرسم منها
    QPainter p;//الطابعة
    QString textTrans="";
    if(m_showPopup==true)//اذا كانت نافذة التفاسير ظاهرة سيجلب  النص
        textTrans=textEdit->toPlainText();

    if(m_curentSafha==1||m_curentSafha==2){     //اذا كانت الصفحة الاولى او الثانية سيعيد الصفحة بكاملها

        QPixmap pixdest(382,468);
        pixdest.fill(Qt::white);
        QRect rect(69,144,320,468);
        QRect rectDest(31,0,320,468);
        p.begin(&pixdest);
        p.drawPixmap(rectDest,pix,rect);//رسم مربع الاية
        p.end();
        sceenFullInterface->setPixmapAya(pixdest);//اعادة الرسم الى مشهد ملء الشاشة
        sceenFullInterface->setInfo(trUtf8("Sura : ")+comboSura->currentText(),
                                    trUtf8("   Jozaa : ")+QString::number(m_jozaa),
                                    trUtf8("   Hizb : ")+QString::number(m_hizb),
                                    trUtf8("   Robaa : ")+QString::number(m_robaa),
                                    trUtf8("   Aya : ")+QString::number(m_aya),
                                    trUtf8("     El Chiekh : ")+comboBoxReciter->currentText(),
                                    textEdit->toPlainText());

        return;//ليس بحاجة الى الباقي
    }



    QRect rectselect(37, top,382,high);//المربع المحدد للاية

    QPixmap pixAyaSource(382,high);//الاطار الذي يتم ارسم الاية عليه
    pixAyaSource.fill(Qt::transparent);//جعل اطار الاية شفافا
    p.begin(&pixAyaSource);//بداية الرسم
    p.drawPixmap(pixAyaSource.rect(),pix,rectselect);//رسم مربع الاية
    p.end();//نهاية رسم مربع الاية
    //  if(x2<60)x2=1;

    int top1=0,top2=40, hight=high, bot=80;

    if(x2<60)
        top1=-40,top2=0,hight=high-40,bot=40;

  //  qDebug()<<"this x2  : "+QString::number(x2);
  //   qDebug()<<"this old hight  : "+QString::number(high);
     //  qDebug()<<"this new hight  : "+QString::number(hight);
    QPixmap pixFull(382,hight);//الصورة التي تعاد الى مشهد ملأ الشاشة
    pixFull.fill(Qt::white);//جعل اطار الاية شفاف

  //qDebug()<<"this top1  : "+QString::number(top1);
 //  qDebug()<<"this top2  : "+QString::number(top2);
p.begin(&pixFull);
    if (high<=45){                          //اذا كانت الاية تتكون من سطر واحد
        int w=(382-(x2-x1))/2;
        QRect rectSource(x1-40,0,x2-x1,40);
        QRect rectDeste(w,0,x2-x1,40);

        p.drawPixmap(rectDeste,pixAyaSource,rectSource);//رسم السطر الاول
    }else if(high<=85){               //اذا كانت الاية تتكون من سطر ين

        //1سطر

        int w=(382-(x2-40))/2;
        QRect rectSource(0,0,x2-40,40);
        QRect rectDeste(w,top1,x2-40,40);
        p.drawPixmap(rectDeste,pixAyaSource,rectSource);//رسم السطر الاول
        //2سطر
        int w2=(382/2)-((382-x1+40)/2);
        QRect rectSource2(x1-40,40,382-x1+40,40);
        QRect rectDeste2(w2,top2,382-x1+40,40);
        p.drawPixmap(rectDeste2,pixAyaSource,rectSource2);
    }else{                                     //اذا كانت الاية تتكون من 3 اسطر
      //  qDebug()<<"line3----------------------------******";

        //1سطر
        int w=(382-(x2-40))/2;

        QRect rectSource(0,0,x2-40,40);
        QRect rectDeste(w,top1,x2-40,40);
        p.drawPixmap(rectDeste,pixAyaSource,rectSource);//رسم السطر الاول
        //2سطر
        QRect rectSource2(0,40,382,high-80);
        QRect rectDeste2(4,top2,382,hight-bot);
        p.drawPixmap(rectDeste2,pixAyaSource,rectSource2);
        //3سطر
        int w2=(382/2)-((382-x1+40)/2);
        QRect rectSource3(x1-40,high-40,382-x1+40,40);
        QRect rectDeste3(w2,hight-40,382-x1+40,40);
        p.drawPixmap(rectDeste3,pixAyaSource,rectSource3);
    }
    //رسم مربع على الصورة
    p.setPen(QColor(164,164,164));
    QRectF rectangle(0.0, 0.0, 381.0, hight-1);
    p.drawRect(rectangle);
    p.end();
    sceenFullInterface->setPixmapAya(pixFull);//اعادة الرسم الى مشهد ملء الشاشة
    sceenFullInterface->setInfo(trUtf8("Sura : ")+comboSura->currentText(),
                                trUtf8("   Jozaa : ")+QString::number(m_jozaa),
                                trUtf8("   Hizb : ")+QString::number(m_hizb),
                                trUtf8("   Robaa : ")+QString::number(m_robaa),
                                trUtf8("   Aya : ")+QString::number(m_aya),
                                trUtf8("     El Chiekh : ")+comboBoxReciter->currentText(),
                                textEdit->toPlainText());//اغادة البيانات الى المشهد
}

//تحريك الصفحة تلقائيا الى اليمين
void MainWindow::animPageRight()
{
    if (m_animEnabled==false){
        newPages();
        return;
    }

    // m_labMask->setLayoutDirection(Qt::RightToLeft);
    m_labMask->setAlignment(Qt::AlignLeft);
    m_labMask->setVisible(true);

    itemRefletLeft->setVisible(true);
    m_labMask->setGeometry(m_difer,0,m_difer,m_pHieght);
    itemRefletLeft->setGeometry(QRect(m_difer-35,0,80,m_pHieght));

 m_labMask->setPixmap( disignePage( m_appPath+"/images/"+m_curentRiwaya+"/"+QString::number(m_curentSafhaRight)+".png"));
    pageLeft->setPixmap(disignePage(m_appPath+"/images/"+m_curentRiwaya+"/"+QString::number(m_curentSafhaLeft)+".png"));
    QPropertyAnimation * anim3 = new QPropertyAnimation(m_labMask, "geometry");
    anim3->setEndValue(QRect(m_pWith,0,m_pWith,m_pHieght));
    anim3->setDuration(750);
    anim3->setEasingCurve(QEasingCurve::OutCubic);

    QPropertyAnimation * anim4 = new QPropertyAnimation(itemRefletLeft, "pos");
    // anim4->setEndValue(QRect(m_pWith,0,60,m_pHieght));
    anim4->setEndValue(QPoint(m_pWith-35,0));
    anim4->setEasingCurve(QEasingCurve::OutCubic);
    anim4->setDuration(750);
    connect( anim3, SIGNAL(finished()), this, SLOT(newPages()));
    QParallelAnimationGroup *group = new QParallelAnimationGroup;

    group->addAnimation(anim3);
    group->addAnimation(anim4);

    group->start();

    m_difer=10;
}
//تحريك الصفحة تلقائيا الى اليسار
void MainWindow::animPageLeft()
{
    if (m_animEnabled==false){
        newPages();
        return;
    }
    int with=m_pWith*2;

    //   m_labMask->setLayoutDirection(Qt::LeftToRight);
    m_labMask->setAlignment(Qt::AlignRight);
    m_labMask->setVisible(true);
    itemRefletRigt->setVisible(true);

    m_labMask->setGeometry(with-m_difer,0,m_difer/2,m_pHieght);
    itemRefletRigt->setGeometry(QRect(with-(m_difer/2)-55,0,80,m_pHieght));
    m_labMask->setPixmap(  disignePage(m_appPath+"/images/"+m_curentRiwaya+"/"+QString::number(m_curentSafhaLeft)+".png"));
    pageRight->setPixmap(disignePage(m_appPath+"/images/"+m_curentRiwaya+"/"+QString::number(m_curentSafhaRight)+".png"));

    QPropertyAnimation * anim3 = new QPropertyAnimation(m_labMask, "geometry");
    anim3->setEndValue(QRect(0,0,m_pWith,m_pHieght));
    anim3->setDuration(750);
    anim3->setEasingCurve(QEasingCurve::OutQuint);

    QPropertyAnimation * anim4 = new QPropertyAnimation(itemRefletRigt, "pos");

    anim4->setEndValue(QPoint(m_pWith-55,0));
    anim4->setEasingCurve(QEasingCurve::OutQuint);
    anim4->setDuration(750);
    connect( anim3, SIGNAL(finished()), this, SLOT(newPages()));
    QParallelAnimationGroup *group = new QParallelAnimationGroup;

    group->addAnimation(anim3);
    group->addAnimation(anim4);

    group->start();
    m_difer=10;
}
//رسم الصفحات
QPixmap MainWindow::disignePage(QString safha)
{

    if (m_themeFolder==trUtf8("default"))
        return safha;

    QPixmap pixMy(safha);
    QPainter p;
    QFileInfo fi(safha);
    QString num=fi.baseName();
    QString imgPath=m_appPath+"/themes/"+m_themeFolder;
    QString arbaaStr=database->myListArbaa->at(num.toInt());
    QString robaa=arbaaStr.section(",",2,2).trimmed();
    QString robaaY=arbaaStr.section(",",1,1).trimmed();
    QString robahizb=arbaaStr.section(",",0,0).trimmed();
    QPixmap pixtop(37,37);
    //-----------بداية الرسم
    p.begin(&pixMy);
  //  pixtop.fill(Qt::white);
  //    p.setCompositionMode(QPainter::CompositionMode_Source);
    p.setRenderHint(QPainter::Antialiasing,true);
    //-------رسم زخارف الجهة العليا والسفلى
    pixtop.load( imgPath+"/top.png") ;
    int count=(m_pWith/pixtop.width())+1;
    for (int i=0;i<count;i++){

        p.drawPixmap(i*pixtop.width(),0,pixtop.width(),38,pixtop);
    }
    pixtop.load( imgPath+"/bot.png") ;
    for (int i=0;i<count;i++){
        p.drawPixmap(i*pixtop.width(),m_pHieght-38,pixtop.width(),38,pixtop);
    }
    //-------رسم زخارف الجهة اليسرى واليمنى
    pixtop.load( imgPath+"/left.png") ;
    int count2=(m_pHieght/pixtop.height())+1;
   // qDebug()<<count2;
    for (int i=0;i<count2;i++){
        p.drawPixmap(0,i*pixtop.height(),38,pixtop.height(),pixtop);
    }
    pixtop.load( imgPath+"/right.png") ;
    for (int i=0;i<count2;i++){
        p.drawPixmap(m_pWith-38,i*pixtop.height(),38,pixtop.height(),pixtop);
    }
    //---------رسم زخارف الزوايا
    pixtop.load( imgPath+"/top_left.png") ;
    p.drawPixmap(0,0,38,38,pixtop);
    pixtop.load( imgPath+"/top_right.png") ;
    p.drawPixmap(m_pWith-38,0,38,38,pixtop);
    pixtop.load( imgPath+"/bot_left.png") ;
    p.drawPixmap(0,m_pHieght-38,38,38,pixtop);
    pixtop.load( imgPath+"/bot_right.png") ;
    p.drawPixmap(m_pWith-38,m_pHieght-38,38,38,pixtop);
    //------رسم ارقام الصفحات
    QRectF rectangle(m_pWith/2-24, m_pHieght-30, 40, 28);
    p.setBrush(QColor(255, 255, 255,200));
    p.drawEllipse(rectangle);
    p.drawText(rectangle, Qt::AlignCenter,num);
    //-------  رسم الارباع و بعض الاستثناءات
    if (robaa.toInt()>0){
        QPixmap pixRbaa(":/img/r"+robaa+".png");
        int pLeft=3;
        int i=fmod(num.toInt(),2);
        if(i==1)
            pLeft=m_pWith-pixRbaa.width()-3;
        p.drawPixmap(pLeft,robaaY.toInt()-pixRbaa.height()/2,pixRbaa);
        if(robaa!="5"){
            QRect rect(pLeft+3,robaaY.toInt(),30,30);
            p.drawText(rect, Qt::AlignCenter,robahizb);
        }
        if (num=="454")
             p.drawPixmap(pLeft,457-pixRbaa.height()/2,QPixmap (":/img/r5.png"));
        if (num=="589")
             p.drawPixmap(pLeft,573-pixRbaa.height()/2,QPixmap (":/img/r5.png"));
    }
    p.end();
    return pixMy;
}
//رسم الصفحات الجديدة
void MainWindow::newPages()
{

    m_labMask->setVisible(false);
    itemRefletLeft->setVisible(false);
    itemRefletRigt->setVisible(false);
    itemSelection->setVisible(true);
    panelPopup->setVisible(m_showPopup);
      emit popupVisible(m_showPopup);
    if (m_curentSafha<3){
        pageRight->setPixmap(m_appPath+"/images/"+m_curentRiwaya+"/"+QString::number(m_curentSafhaRight)+".png");
        pageLeft->setPixmap(m_appPath+"/images/"+m_curentRiwaya+"/"+QString::number(m_curentSafhaLeft)+".png");
    } else{
        pageRight->setPixmap(disignePage(m_appPath+"/images/"+m_curentRiwaya+"/"+QString::number(m_curentSafhaRight)+".png"));
        pageLeft->setPixmap(disignePage(m_appPath+"/images/"+m_curentRiwaya+"/"+QString::number(m_curentSafhaLeft)+".png"));
    }

    if (m_curentSafhaRight==1){
        btnRight->setEnabled(false);
    }else{
        btnRight->setEnabled(true);
    }
    if (m_curentSafhaLeft==604){
        btnLeft->setEnabled(false);
    }else{
        btnLeft->setEnabled(true);
    }
    for (int i = 0; i <items.count(); ++i) {
        m_scene->removeItem(items.at(i));
        delete items.at(i);
    }
    items.clear();
    //رسم ازرار على الايات
    QString lineLeft=database->myListSafhat->at(m_curentSafhaLeft);
    QString lineRight=database->myListSafhat->at(m_curentSafhaRight);

    int countRight=lineRight.count("|");
    int countLeft=lineLeft.count("|");

    QPixmap mypix(28,28);
    mypix.fill(Qt::transparent);
    //--------------ازرار الصفحة اليمنى
    for (int r=0;r <countRight+1 ;r++){
        QString txt=lineRight.section("|",r,r).trimmed();
        QString id =txt.section(",",0,0).trimmed();
        int mx =txt.section(",",1,1).trimmed().toInt();
        int my =txt.section(",",2,2).trimmed().toInt();
        //        mx=(mx*90)/100;
        //        my=(my*90)/100;
        Pixmap *item = new Pixmap(mypix);
        items << item;
        m_scene->addItem(item);
        item->setGeometry(QRectF((m_pWith+mx)-14,my-14,28,28));
        item->setCursor(Qt::PointingHandCursor);
        item->setData(0,id);
        connect(item, SIGNAL(release()), this, SLOT(goAyaSelected()));
    }
    //-------------ازرار الصفحة اليسرى
    for (int r=0;r <countLeft+1 ;r++){
        QString txt=lineLeft.section("|",r,r).trimmed();
        QString id =txt.section(",",0,0).trimmed();
        int mx =txt.section(",",1,1).trimmed().toInt();
        int my =txt.section(",",2,2).trimmed().toInt();
        //mx=(mx*90)/100;
        //my=(my*90)/100;
        Pixmap *item = new Pixmap(mypix);
        items << item;
        m_scene->addItem(item);
        item->setGeometry(QRectF(mx-14,my-14,28,28));
        item->setCursor(Qt::PointingHandCursor);
        item->setData(0,id);
        connect(item, SIGNAL(release()), this, SLOT(goAyaSelected()));
    }

}

void MainWindow::goAyaSelected()
{
    Pixmap *currentItem= qobject_cast<Pixmap *>(sender());
    int pos=currentItem->data(0).toInt();
    setCurentPos(pos);
}

//------------------------move left to right----------------------

void MainWindow::goNextEenter( )
{
    m_difer=15;
    //   اعطاء صورة مطوية عند ادخال المؤشر للحافة اليسرى ووضعها على الاحداثية س=0 ع=0
    picMoved->setPixmap(QPixmap(":/img/ply.png"));
    picMoved->setPos(0,0);
}

void MainWindow::goNextLeave()
{
     //   اعطاء صورة شفافة عند اخراج المؤشر المؤشر من للحافة اليسرى
    QPixmap pix(0,0);
    pix.fill(Qt::transparent);
    picMoved->setPixmap(pix);

}

void MainWindow::goNextPrissed( )
{
     if (m_animEnabled==false){
          on_actionNextPage_triggered();
         return;
     }
     //اعلام البرنامج ببداية السحب
    m_bLeft=true;
    itemSelection->setVisible(false);
    panelPopup->setVisible(false);
//جلب الصورة اليمنى واليسرى
    m_pixRigtMoved=(disignePage(m_appPath+"/images/"+m_curentRiwaya+"/"+QString::number(m_curentSafhaLeft+1)+".png"));
    m_pixLeftMoved=(   disignePage(m_appPath+"/images/"+m_curentRiwaya+"/"+QString::number(m_curentSafhaLeft+2)+".png"));

}

void MainWindow::goNextRelease( )
{
//اعلام البرنامج بنهاية السحب عند افلات المؤشر
    m_bLeft=false;
    itemSelection->setVisible(true);
     panelPopup->setVisible(m_showPopup);
        emit popupVisible(m_showPopup);

    if(m_difer<150)
        return;

    QString mtxt=database->myListSafhat->at(m_curentSafhaLeft+1);
    m_id=mtxt.section(",",0,0).trimmed().toInt();
    setCurentPos(m_id);

}

void MainWindow::goNextMoved( )
{
    //عند السحب
    if (m_bLeft==true){
        int tpos=this->pos().x();
        if(this->isMaximized()||this->isFullScreen())
            tpos=0;
        int w=(ui->graphicsView->width()/2)-m_pWith;
        if (w<0)
            w=0;
        //معرفة موضع المؤشر
        int    wx = QCursor::pos().x()-tpos-w;
        if (wx>900)
            return;
        m_difer=wx/2;
        moveLeftToRight();
    }
}

void MainWindow::moveLeftToRight()
{
// الرسم بعد تلقي الاشارة بتغير موضع الماوس
    QPixmap   pix1(m_difer*2,m_pHieght);
    QPainter p;
    p.begin(&pix1);
   //اقتطاع الصورة ورسمها على حاوي الرسم
    p.drawPixmap(0,0,m_difer,m_pHieght,m_pixLeftMoved,0,0,m_difer,m_pHieght);
    p.drawPixmap(m_difer,0,m_difer,m_pHieght,m_pixRigtMoved,m_pWith-m_difer,0,m_difer,m_pHieght);
    p.setPen(QColor(128,128,128,180));
    p.drawPixmap(m_difer-25,0,80,m_pHieght,QPixmap(":/img/reflet.png"));
    p.drawLine((m_difer*2)-1,0,(m_difer*2)-1,m_pHieght);
    p.end();
    picMoved->setPixmap(pix1);
}

//-----------------go right to left---------------------------
void MainWindow::goPrevEenter()
{
    if(m_curentSafhaRight==1)
        return;

    picMoved->setPixmap(QPixmap(":/img/plyR.png"));
    picMoved->setPos((m_pWith*2)-29,0);

}

void MainWindow::goPrevLeave()
{

    QPixmap pix(0,0);
    pix.fill(Qt::transparent);
    picMoved->setPixmap(pix);

}

void MainWindow::goPrevPrissed( )
{
    if (m_animEnabled==false){
         on_actionPrevPage_triggered();
        return;
    }
      if(m_curentSafhaRight>1){
           m_bRight=true;

           itemSelection->setVisible(false);
           panelPopup->setVisible(false);

           m_pixRigtMoved=( disignePage(m_appPath+"/images/"+m_curentRiwaya+"/"+QString::number(m_curentSafhaRight-2)+".png"));
           m_pixLeftMoved=( disignePage(m_appPath+"/images/"+m_curentRiwaya+"/"+QString::number(m_curentSafhaRight-1)+".png"));
       }
}

void MainWindow::goPrevRelease( )
{

    m_bRight=false;
      panelPopup->setVisible(m_showPopup);
      itemSelection->setVisible(true);
      emit popupVisible(m_showPopup);
    if(m_difer<300)
        return;

    QString mtxt=database->myListSafhat->at(m_curentSafhaRight-1);
    m_id=mtxt.section(",",0,0).trimmed().toInt();
    setCurentPos(m_id);
}

void MainWindow::goPrevMoved()
{

    if (m_bRight==true){
        picMoved->setPos(0,0);
        int tpos=this->pos().x();
        if(this->isMaximized()||this->isFullScreen())
            tpos=0;
        int w=(ui->graphicsView->width()/2)-(m_pWith-10);
        if (w<0)
            w=0;
        int    wx = QCursor::pos().x()-tpos-w;
        if (wx<40)
            return;
        m_difer=912-wx;
        moveRightToLeft();
    }
}


void MainWindow::moveRightToLeft()
{

   int with=m_pWith*2;

    QPixmap   pix1(with,m_pHieght);
    pix1.fill(Qt::transparent);
    QPainter p;
    p.begin(&pix1);
    p.drawPixmap(with-(m_difer),0,m_difer/2,m_pHieght,m_pixLeftMoved,0,0,m_difer/2,m_pHieght);
    p.drawPixmap(with-(m_difer/2),0,m_difer/2,m_pHieght,m_pixRigtMoved,m_pWith-(m_difer/2),0,m_difer/2,m_pHieght);
    p.setPen(QColor(128,128,128,200));
    p.drawPixmap((with-(m_difer/2))-52,0,80,m_pHieght,QPixmap(":/img/refletRight.png"));
    p.drawLine(with-(m_difer),0,with-(m_difer),m_pHieght);
    p.end();
    picMoved->setPixmap(pix1);
}

//-------------------------go page and pos--------------------
void MainWindow::goSura(int index)
{
    // i/nt idx=comboSura->currentIndex();
    QVariant txt=comboSura->itemData(index);
    QString pos=txt.toString().section(",",0,0);
    setCurentPos(pos.toInt());
}

void MainWindow::goAya()
{
       int idx=comboSura->currentIndex();
       QVariant txt=comboSura->itemData(idx);
       QString pos=txt.toString().section(",",0,0);
       setCurentPos(pos.toInt()+spinAya->value()-1);
}

void MainWindow::goJozaa()
{
    if(spinJozaa->value()==m_jozaa)
        return;
     // qDebug()<<"spinjozaa :" +QString::number(m_jozaa);
    if( database->myListJozaa->count()>0){
  int idx=  database->myListJozaa->at(spinJozaa->value()-1);
   setCurentPos(idx);
    }
}

void MainWindow::goHizb()
{
    if(spinHizb->value()==m_hizb)
        return;
    //qDebug()<<"spinhizb :" +QString::number(m_hizb);
    if( database->myListJozaa->count()>0){
        int idx=  database->myListHizb->at(spinHizb->value()-1);
        setCurentPos(idx);
    }
}

void MainWindow::goPage()
{
    if(spinSafha->value()==m_curentSafha)
        return;

    QString mtxt=database->myListSafhat->at(spinSafha->value());
    int id=mtxt.section(",",0,0).trimmed().toInt();
     setCurentPos(id);
}

void MainWindow::setSora(int sora)
{
    if(sora>114||sora <1){
     //     qDebug()<<"sura :"+QString::number(sora)+" no existe";
        return ;
    }
     int i=database->myListSura->at(sora-1);
    setCurentPos(i);

}

void MainWindow::setJozaa(int jozaa)
{
    if (jozaa>30||jozaa<1){
    //    qDebug()<<"jozaa :"+QString::number(jozaa)+" no existe";
        return ;
    }
    int i=database->myListJozaa->at(jozaa-1);
         setCurentPos(i);

}

void MainWindow::setHizb(int hizb)
{
    if (hizb>60||hizb<1){
      //    qDebug()<<"hizb :"+QString::number(hizb)+" no existe";
        return ;
    }
    int i=database->myListHizb->at(hizb-1);
         setCurentPos(i);

}

void MainWindow::setAya(int sora,int aya)
{
    if(sora>114||sora <1){
      //   qDebug()<<"sura :"+QString::number(sora)+" no existe";
        return ;
    }
     int i=database->myListSura->at(sora-1);
     QVariant txt=comboSura->itemData(sora-1);
     QString max=txt.toString().section(",",1,1);
     if(aya>max.toInt()||aya <1){
        //  qDebug()<<"aya :"+QString::number(aya)+" no existe";
           setCurentPos(i);
         return ;
     }
      setCurentPos(i+aya-1);

}

void MainWindow::setSpinAyaMaximum(int index)
{

    QVariant txt=comboSura->itemData(index);

    QString i =txt.toString().section(",",1,1);
    spinAya->setMaximum(i.toInt());
    spinAya->setMinimum(1);

}

//-------------------------phonon-----------------------------------------------
void MainWindow::stateChanged(Phonon::State newstate, Phonon::State oldstate)
{
    Q_UNUSED(oldstate);

    switch (newstate) {
    case Phonon::ErrorState:
        if (m_MediaObject.errorType() == Phonon::FatalError) {
            // ui->actionPlayPause->setEnabled(false);
            m_MediaObject.clearQueue();
            m_MediaObject.stop();
        } else {
            m_MediaObject.pause();
        }
        break;

    case Phonon::StoppedState:
        ui->actionPlayPause->setIcon(playIcon);
        isPlay=false;
        break;

    case Phonon::LoadingState:
        break;

    case Phonon::BufferingState:
        break;

    case Phonon::PausedState:
        ui->actionPlayPause->setIcon(playIcon);
        if (m_MediaObject.currentSource().type() != Phonon::MediaSource::Invalid){
            ui->actionPlayPause->setEnabled(true);
        } else {
            ui->actionPlayPause->setEnabled(false);
        }
        break;

    case Phonon::PlayingState:

        ui->actionPlayPause->setEnabled(true);
        ui->actionPlayPause->setIcon(pauseIcon);
        isPlay=true;
        break;
    }

}

void MainWindow::chargeLastAndFirstAya()
{
    if(m_autoRepeatPage==true){
    QString  txt=   database->myListSafhat->at(m_curentSafha);
     int i=  txt.count("|");
      m_repeatAyaFirst=txt.section(",",0,0).trimmed().toInt();
      QString lastTxt=txt.section("|",i,i).trimmed();
        m_repeatAyaLast=lastTxt.section(",",0,0).trimmed().toInt();

    }else if (m_autoRepeatSura==true){
        int sura=m_sura-1;
       m_repeatAyaFirst=database-> myListSura->at(sura);
       m_repeatAyaLast=database-> myListSura->at(sura+1)-1;
       if (m_repeatAyaLast==-1)
           m_repeatAyaLast=6236;
    }

}

void MainWindow::mediaFinished()
{
    if(m_plaOne==true){
        m_MediaObject.stop();
        m_plaOne=false;
        return;
    }
    if(m_autoPlayNext==false){

        //تكرار الاية
        if (m_autoRepeatOne==true){
            if (m_isRepeatNumber==true){
                if(m_numPlayed>=m_repeatNumber){
                    m_numPlayed=1;

                    setCurentPos(m_id+1);
                    mediaPlay();
                      return;
                }
            }
            m_MediaObject.setCurrentSource(m_MediaObject.currentSource());
            m_MediaObject.seek(0);
            m_MediaObject.play();
            m_numPlayed++;
            //   qDebug()<<numRepeat;
            return;
        }
        // تكرار الصفحة او تكرار السورة
        if (m_autoRepeatPage==true||m_autoRepeatSura==true||m_autoRepeatFromTo){
            if(m_id>=m_repeatAyaLast){
                if (m_isRepeatNumber==true){
                    if(m_numPlayed>=m_repeatNumber){
                        m_numPlayed=1;
                        setCurentPos(m_id+1);
                    }else{
                        setCurentPos(m_repeatAyaFirst);
                        m_numPlayed++;
                    }
                }else{
                    setCurentPos(m_repeatAyaFirst);
                }
            }else{
                setCurentPos(m_id+1);
            }
            return;
        }
    }
    //قراءة متتالية

    setCurentPos(m_id+1);


}

//-------------end phonon----------

///------------------------------Actions---------------------------------------------
void MainWindow::on_actionNextPage_triggered()
{
    if (m_curentSafha==604)
        return;
    QString mtxt=database->myListSafhat->at(m_curentSafha+1);
     int id=mtxt.section(",",0,0).trimmed().toInt();
     setCurentPos(id);
}

void MainWindow::on_actionPrevPage_triggered()
{
    if (m_curentSafha==1)
        return;
    QString mtxt=database->myListSafhat->at(m_curentSafha-1);
   int id=mtxt.section(",",0,0).trimmed().toInt();
    setCurentPos(id);
}

void MainWindow::on_actionNextSura_triggered()
{
    if(m_sura==114)
        return;
     int i=database->myListSura->at(m_sura);
    setCurentPos(i);
}

void MainWindow::on_actionPrevSura_triggered()
{
    if(m_sura==1)
        return;
      int i=database->myListSura->at(m_sura-2);
    setCurentPos(i);
}

void MainWindow::on_actionNextAya_triggered()
{
    if (m_id==6236)
        return;
     setCurentPos(m_id+1);
}

void MainWindow::on_actionPrevAya_triggered()
{
    if (m_id==1)
            return;
         setCurentPos(m_id-1);
}

void MainWindow::on_actionOptions_triggered()
{

    getOption(0,trUtf8("General Options"));

}
void MainWindow::on_actionRepeatOption_triggered()
{
     getOption(1,trUtf8("Repeat Options"));
}
void MainWindow::on_actionNavigation_toggled(bool arg1)
{

   //     openCloseNavigator(arg1);
    ui->dockWidget->setVisible(arg1);
}
void MainWindow::fullScreen()
{
    if(m_fullIndex<0||m_fullIndex>myListSceen.count()-1)
        m_fullAnimated=false;
    if(this->isFullScreen()){
        ui->toolBar->setVisible(true);
        ui->menuBar->setVisible(m_showMenu);
        this->showNormal();
        ui->graphicsView->setContextMenuPolicy(Qt::NoContextMenu);
        ui->graphicsView->setScene(m_scene);
        ui->graphicsView->setSceneRect(QRectF(0.0,0.0,912.0,672.0));
        ui->graphicsView->updateSceneRect(QRectF(0.0,0.0,912.0,672.0));
//        if(myListSceen.count()>0)
//        sceenFullInterface->setAnimationEnabled(false);


    }else{
        int w=QApplication::desktop()->geometry().width();
        int h=QApplication::desktop()->geometry().height();

        if(m_fullAnimated==false){
            ui->graphicsView->setSceneRect(QRectF(0.0,0.0,912.0,672.0));
            ui->graphicsView->updateSceneRect(QRectF(0.0,0.0,912.0,672.0));
            ui->graphicsView->setScene(m_scene);
            this->showFullScreen();

        }else  {
            ui->toolBar->setVisible(false);
            ui->menuBar->setVisible(false);
            this->showFullScreen();
            ui->graphicsView->setSceneRect(QRectF(0.0,0.0,w,h));
            ui->graphicsView->updateSceneRect(QRectF(0.0,0.0,w,h));
            //     ui->graphicsView->setScene(scenfull);
            ui->graphicsView->setContextMenuPolicy(Qt::CustomContextMenu);
            //     scenfull->setBackgroundDir(m_fullScreenBgr);
   setCurentPos(m_id);
     if(myListSceen.count()>0){
            sceenFullInterface->setGraphicSceen(ui->graphicsView);

            sceenFullInterface->setAnimationEnabled(m_fullAnimEnable);
}
        }

    }

}

void MainWindow::on_actionFullScreen_triggered()
{
   fullScreen();
}

void MainWindow::comboBoxSoraJozaa_currentIndexChanged(int index)
{
    if (index==0){
        database-> treeChargeSoura(ui->treeWidgetIndex,true,comboSura,m_layouDir,m_sura-1);
    }else{

       database-> treeChargeJozaa(ui->treeWidgetIndex);
    }
}

void MainWindow::treeWidgetIndex_itemActivated(QTreeWidgetItem *item, int )
{
    int id =item->text(1).toInt();

    setCurentPos(id);
}
//-----------action phonon------------
void MainWindow::on_actionPlayPause_triggered()
{
    if (m_MediaObject.state() == Phonon::PlayingState){
        m_MediaObject.pause();
        return;
    }
    mediaPlay();
}

void MainWindow::mediaPlay()
{
    QString userFileName=QDir::homePath()+"/.elforkane/"+m_soundPath+"/"+m_soundName;
    QString fileName=m_soundPath+"/"+m_soundName;
    QUrl url(m_soundUrl+"/"+m_soundName);
 //   qDebug()<<fileName;
 //   qDebug()<<url;
    if (m_MediaObject.currentTime() == m_MediaObject.totalTime())
        m_MediaObject.seek(0);

    //-------------------------------
    if(QFile::exists(fileName)){
        if(m_MediaObject.currentSource().fileName()!=fileName){
            m_MediaObject.clearQueue();
            if (m_aya==1&&m_sura!=9&&m_sura!=1&&m_reciteBasmala==true){
                m_MediaObject.setCurrentSource(QString(m_appPath+"/bismillah.mp3"));
                m_MediaObject.enqueue(fileName);

            }else{
                m_MediaObject.setCurrentSource(fileName);
            }
        }
        m_MediaObject.play();
    }else if(QFile::exists(userFileName)){
        if(m_MediaObject.currentSource().fileName()!=userFileName){
            m_MediaObject.clearQueue();
            if (m_aya==1&&m_sura!=9&&m_sura!=1&&m_reciteBasmala==true){
                m_MediaObject.setCurrentSource(QString(m_appPath+"/bismillah.mp3"));
                m_MediaObject.enqueue(userFileName);

            }else{
                m_MediaObject.setCurrentSource(userFileName);
            }
        }
        m_MediaObject.play();
    }else{
        if(url.isValid()){
            if(m_MediaObject.currentSource().url()!=url&&m_reciteBasmala==true){
                m_MediaObject.clearQueue();
                if (m_aya==1&&m_sura!=9&&m_sura!=1){
                    m_MediaObject.setCurrentSource(QString(m_appPath+"/bismillah.mp3"));
                    m_MediaObject.enqueue(url);

                }else{
                    m_MediaObject.setCurrentSource(url);
                }
            }
            m_MediaObject.play();
        }
    }

 //   qDebug()<<"user = "+userFileName;


}

void MainWindow::on_actionStopMedia_triggered()
{
    m_MediaObject.stop();
    isPlay=false;
}


//-----------التفاسير و التراجم------------
void MainWindow::popup_toggled(bool checked)
{
    m_showPopup=checked;
  emit popupVisible(checked);
    panelPopup->setVisible(checked);
   convertTextToHtm(database->getTranslation(m_id));
}


   void MainWindow::translationChanged()
   {

       QAction *action = qobject_cast<QAction *>(sender());
       if (action){
           QVariant data=action->data();
           QString txt=action->text();
           database->openDb(m_appPath+"/translat/"+data.toString());
           convertTextToHtm(database->getTranslation(m_id));
           labelTransTefsir->setText(txt);
           m_showPopup=true;
           emit popupVisible(true);
           isTefsirPopup=false;
           panelPopup->setVisible(true);

           m_curTranslation=myListActionTrans.indexOf(action);

       }
   }
   void MainWindow:: tefsirChanged()
   {
       QAction *action = qobject_cast<QAction *>(sender());
       if (action){
           QVariant data=action->data();
           QString txt=action->text();
           database->openDb(m_appPath+"/tafasir/"+data.toString());
           convertTextToHtm(database->getTranslation(m_id));
           labelTransTefsir->setText(txt);
           m_showPopup=true;
           emit popupVisible(true);
           isTefsirPopup=true;
           panelPopup->setVisible(true);

       }
   }

   void MainWindow::txtQuran()
   {
         database->openDb(m_appPath+"/quran.db");
          convertTextToHtm(database->getTranslation(m_id));
          labelTransTefsir->setText(trUtf8("Quran txt"));
          m_showPopup=true;
          emit popupVisible(true);
          isTefsirPopup=false;
          panelPopup->setVisible(true);

   }

void MainWindow::comboBoxResiter_activated(int index)
{
    m_receter=index;
    QString txt=comboBoxReciter-> itemData(index).toString();
    m_soundPath=txt.section("|",0,0);
    m_soundUrl=txt.section("|",1,1);
  //  qDebug()<<"soundPath ="+m_soundPath;
  //      qDebug()<<"soundUrl ="+m_soundUrl;
}

void MainWindow::lineEditSearchTree_textChanged(const QString &arg1)
{
    if(arg1==trUtf8("Search"))
        return;
    database->searchInTreeview(ui->treeWidgetIndex,arg1,0);
}

void MainWindow::on_graphicsView_customContextMenuRequested(const QPoint )
{
    QMenu menu(this);
    menu.addAction(ui->actionFullScreen);
      menu.addAction(ui->actionEnableAnimFull);
    menu.addSeparator();
    menu.addMenu(ui->menu_edit);
    menu.addMenu(ui->menuTranslation);
     menu.addSeparator();
    menu.addAction(ui->actionQuit);
    menu.exec(QCursor::pos());
}

void MainWindow::hidePopup()
{
   actTansTefsir->setChecked(false);
emit popupVisible(false);

}


void MainWindow::getOption(int tab,QString title)
{
    QList <QString >listRiwayatText;
    QList <QString >listRiwayatData;
    QDir dir;

    if(dir.exists(m_appPath+"/images/hafs")){
        listRiwayatText.append(trUtf8("Riwayat hafs"));
        listRiwayatData.append("hafs");
    }
    if(dir.exists(m_appPath+"/images/hafs-colors")){
        listRiwayatText.append(trUtf8("Riwayat hafs by colors"));
        listRiwayatData.append("hafs-colors");
    }
    if(dir.exists(m_appPath+"/images/warsh")){
        listRiwayatText.append(trUtf8("Riwyat warsh"));
        listRiwayatData.append("warsh");
    }
    if(dir.exists(m_appPath+"/images/warsh-colors")){
        listRiwayatText.append(trUtf8("Riwayat warsh by colors"));
        listRiwayatData.append("warsh-colors");
    }

    DialogOption *dlg=new DialogOption(this);

    dlg->setAppPath(m_appPath);
    //repeat settings
    dlg->setAutoPlayNext(m_autoPlayNext);
    dlg->setAutoRepeatOne(m_autoRepeatOne);
    dlg->setAutoRepeatPage(m_autoRepeatPage);
    dlg->setautoRepeatSura(m_autoRepeatSura);
    dlg->setAutoRepeatFromTo(m_autoRepeatFromTo);
    dlg->setNumberRepeats(m_repeatNumber);
    dlg->setRepeatNumber(m_isRepeatNumber);
    dlg->setRepeatAyaFirst(m_repeatAyaFirst);
    dlg->setRepeatAyaLast(m_repeatAyaLast);
    //generale settings

    dlg->setShowMediaControl(m_showMediaControl);
    dlg->setAnimEnabled(m_animEnabled);
    dlg->setFitInView(m_fitInView);
    dlg->setMinimizToTry(m_minimizToTry);
    dlg->setTextInIcons(m_textIcon);
    dlg->setCadrFolder(m_themeFolder);
    dlg->setLng(m_lng);
    dlg->setInfoDely(m_infoDely);
    dlg->setSpinMax(spinAya->maximum());
    dlg->setSelectColor(m_selectColor);
    dlg->setShowMenu(m_showMenu);
    dlg->setShowSelection(m_showSelection);
    dlg ->setReciteBasmala(m_reciteBasmala);
    dlg->setFullSceenAnimated(m_fullAnimated);
   //dlg->setFullBackgroundDir(m_fullScreenBgr);
    dlg->setCurTab(tab);
    dlg->setWindowTitle(title);
    dlg->setListFullSceen(listSceenName,m_fullIndex);
    dlg->listSceen=myListSceen;
    //dlg->chargeSettings();
dlg->setRiwayat(listRiwayatText,listRiwayatData,m_curentRiwaya);

    if (dlg->exec() == QDialog::Accepted){
        m_themeFolder=dlg->cadrFolder;
        m_animEnabled=dlg->animEnabled;
        m_fitInView=dlg->fitInView;
        m_minimizToTry=dlg->minimizToTry;
        m_textIcon=dlg->textInIcons;
        m_infoDely=dlg->infoDely;
        m_lng=dlg->lng;
        m_selectColor=dlg->selectColor;
        m_showMediaControl=dlg->showMediaControl;
        m_autoRepeatFromTo=dlg->autoRepeatFromTo;
        m_autoRepeatOne=dlg->autoRepeatOne;
        m_autoRepeatPage=dlg->autoRepeatPage;
        m_autoRepeatSura=dlg->autoRepeatSura;
        m_autoPlayNext=dlg->autoPlayNext;
        m_repeatNumber=dlg->numberRepeats;
        m_isRepeatNumber=dlg->isRepeatNumber;
        m_showMenu=dlg->showMenu;
        m_showSelection=dlg->showSelection;
        m_reciteBasmala=dlg->reciteBasmala;
        ui->menuBar->setVisible(m_showMenu);
        m_fullAnimated=dlg->fullAnimated;
      m_fullIndex=dlg->fullIndex;
      m_curentRiwaya=dlg->riwayat;
     database-> chargeCsvs(m_curentRiwaya);
     if(m_fullIndex<0)m_fullIndex=0;
     if(myListSceen.count()>0)
           sceenFullInterface=myListSceen.at(m_fullIndex);
        locateThemePath();
        newPages();
    //  itemSelection->setPixmap( updatePixSelect(150,382,382));
        setCurentPos(m_id);
        this->resize(this->size().width()+1,this->size().height()+1);

        trayIcon->setVisible(m_minimizToTry);
        if(m_textIcon==true){
            ui->toolBar->setToolButtonStyle(Qt::ToolButtonTextUnderIcon);
        }else{
            ui->toolBar->setToolButtonStyle(Qt::ToolButtonIconOnly);
        }

        if (dlg->autoRepeatFromTo==true){
            int sura=database-> myListSura->at(m_sura-1);
            m_repeatAyaFirst=sura+dlg->repeatAyaFirst-1;
            m_repeatAyaLast=sura+dlg->repeatAyaLast-1;
            m_numPlayed=1;
        }

    }
}

void MainWindow::on_actionAddReceter_triggered()
{
    DialogAddReciter *dlg=new DialogAddReciter(this);
    dlg->setWindowTitle(trUtf8("Add Receter"));
    if (dlg->exec() == QDialog::Accepted){
       comboBoxReciter->addItem(dlg->reciterName,dlg->dataName);
         }

}
void MainWindow::editReciter()
{
    int index=comboBoxReciter->currentIndex();
          DialogAddReciter *dlg=new DialogAddReciter(this);
          dlg->setWindowTitle(trUtf8("Edit Receter"));
          dlg->setReceterName(comboBoxReciter->currentText());
          dlg->setDirName(m_soundPath);
          dlg->setUrlName(m_soundUrl);
          if (dlg->exec() == QDialog::Accepted){
             comboBoxReciter->setItemText(index,dlg->reciterName);
             comboBoxReciter->setItemData(index,dlg->dataName);
             m_soundPath=dlg->dataName.section("|",0,0);
             m_soundUrl=dlg->dataName.section("|",1,1);
           }
}

void MainWindow::on_actionEditeReceter_triggered()
{
    editReciter();
}
//حذف المقرئ المحدد
void MainWindow::on_actionRemoveReceter_triggered()
{
    QMessageBox msgBox;
    //msgBox.setText("The document has been modified.");
    msgBox.setIcon(QMessageBox::Question);
    msgBox.setText(QString(trUtf8("Do you want to delete %1 ?")).arg(comboBoxReciter->currentText()));
    msgBox.setStandardButtons(QMessageBox::Yes | QMessageBox::No );
    msgBox.setDefaultButton(QMessageBox::No);
    int ret = msgBox.exec();
    switch (ret) {
    case QMessageBox::Yes:
        comboBoxReciter->removeItem(comboBoxReciter->currentIndex());
        break;
    case QMessageBox::No:
        // Don't Delete was clicked
        break;

    default:
        // should never be reached
        break;
    }

}


void MainWindow::on_actionAbout_triggered()
{
    DialogAbout *dlg=new DialogAbout(this);
    dlg->exec() ;
}

void MainWindow::on_actionQuranText_triggered()
{
    txtQuran();


}

void MainWindow::on_actionRceterEdite_triggered()
{
    editReciter();
}



bool MainWindow::eventFilter(QObject *obj, QEvent *event)
 {

 if (obj ==  ui->lineEditSearchTree) {
         if (event->type() == QEvent::FocusIn && ui->lineEditSearchTree->text()==trUtf8("Search")) {
             ui->lineEditSearchTree->setText("");
             ui->lineEditSearchTree->setStyleSheet("");
             return true;
         }else if (event->type() == QEvent::FocusOut && ui->lineEditSearchTree->text().isEmpty()){

                ui->lineEditSearchTree->setText(trUtf8("Search"));
                  ui->lineEditSearchTree->setStyleSheet("QLineEdit {font: italic;color: rgb(115, 115, 115);}");
               return true;
         }

}
 return QMainWindow::eventFilter(obj, event);
 }

void MainWindow::on_toolButtonGoSearch_clicked()
{
    if(ui->lineEditSearch->text().isEmpty())
        return;


    int option;
    if(ui->radioButtonSearch->isChecked())
        option=0;
    if(ui->radioButtonSearchFirst->isChecked())
        option=1;
    if(ui->radioButtonSearchLast->isChecked())
        option=2;
    if(ui->radioButtonAdvensed->isChecked())
        option=3;
    if (option==3&&ui->lineEditSearchAnd->text().isEmpty())
        return;
    QString orAnd;
    if(ui->checkBoxAnd->isChecked()==true){
        orAnd="and";
   }else if(ui->checkBoxOr->isChecked()==true){
        orAnd="or";
    }
    database->dataSearchString(ui->treeWidgetSearch,ui->lineEditSearch->text(),ui->lineEditSearchAnd->text(),orAnd,option);
}



void MainWindow::on_lineEditSearch_returnPressed()
{
    on_toolButtonGoSearch_clicked();
}

void MainWindow::on_lineEditSearchAnd_returnPressed()
{
      on_toolButtonGoSearch_clicked();
}

void MainWindow::on_treeWidgetSearch_itemActivated(QTreeWidgetItem *item, int )
{
    int id =item->text(3).toInt();
    setCurentPos(id);
}



void MainWindow::on_actionEnableAnimFull_toggled(bool arg1)
{
      m_fullAnimEnable=arg1;
      if(this->isFullScreen())
    sceenFullInterface->setAnimationEnabled(arg1);


}

void MainWindow::loadPlugin()
{
    QDir pluginsDir(qApp->applicationDirPath());
#if defined(Q_OS_WIN)

    pluginsDir.cdUp();
#elif defined(Q_OS_MAC)
    if (pluginsDir.dirName() == "MacOS") {
        pluginsDir.cdUp();
        pluginsDir.cdUp();
        pluginsDir.cdUp();
    }
#else
    pluginsDir.cdUp();
    qDebug()<<pluginsDir;
#endif
    if(QFile::exists(m_appPath+"/plugins")){
      pluginsDir.cd(m_appPath+"/plugins");
   }else  if(QFile::exists(pluginsDir.path()+"/lib/elforkane/plugins")){
         pluginsDir.cd("lib/elforkane/plugins");
    }else if(QFile::exists(pluginsDir.path()+"/lib64/elforkane/plugins")){
         pluginsDir.cd("lib64/elforkane/plugins");
    }
//       qDebug()<<"this plugin m_appPath  :"+m_appPath+"/plugins";
//    qDebug()<<"this plugin lib  :"+pluginsDir.path()+"/lib/elforkane/plugins";
//      qDebug()<<"this plugin lib64  :"+pluginsDir.path()+"/lib64/elforkane/plugins";
     qDebug()<<"plugins path  :"+pluginsDir.path();

    foreach (QString fileName, pluginsDir.entryList(QDir::Files)) {
        QPluginLoader pluginLoader(pluginsDir.absoluteFilePath(fileName));
        QObject *plugin = pluginLoader.instance();

        if (plugin) {
            sceenFullInterface    = qobject_cast<SceenFullInterface *>(plugin);
            if (sceenFullInterface){
                myListSceen.append(qobject_cast<SceenFullInterface *>(plugin));
                listSceenName.append(plugin->objectName());

            }
        }
    }
int count=myListSceen.count();
    if(count<1||m_fullIndex<0||m_fullIndex>count-1){
        m_fullAnimated=false;
        m_fullIndex=0;
    }else{
         sceenFullInterface=myListSceen.at(m_fullIndex);
    }
}

//void MainWindow::on_toolButton_clicked()
//{
//database->chargeTree(ui->treeWidgetIndex);
//}

//void MainWindow::on_pushButton_clicked()
//{
//       QString dataAyat=m_appPath+"/quran.xml";
//       QFile fileAyat(dataAyat);
//       if (!fileAyat.open(QFile::WriteOnly)){
//         return ;
//           qDebug()<<m_appPath+"/quran.xml";
//       }
//       QTextStream out(&fileAyat);
//       QString line;

//       out << "<?xml version='1.0' encoding='UTF-8'?>\n";
//       out <<"<Departments>\n";

//       int topCount=ui->treeWidgetIndex->topLevelItemCount();
//       for (int i=0;i<topCount;i++){
//           QTreeWidgetItem *item=ui->treeWidgetIndex->topLevelItem(i);
//           QString txtSura=item->text(0);
//           QString txtSuraEn=item->data(0,1).toString();
//           QString txt= "<Department Name=\""+txtSura+"\" Ename=\""+txtSuraEn+"\">\n";
//           out <<txt;
//           int itemCount=item->childCount();
//           for(int r=0;r<itemCount;r++){
//                 QTreeWidgetItem *items=item->child(r);
//               QString txtAya=items->text(0);
//             //   <Item ID="1_1" >1- بسم الله الرحمن الرحيم</Item>
//     QString txt= "<Item> "+txtAya+" </Item>\n";
//               out <<txt;
//           }
//     out<<"</Department>\n";
//       }
//       out<< "</Departments>";
//}
