/****************************************************************************
//   elforkane Copyright (C) 2012 yahia nouah <yahiaui@gmail.com>
//
//      This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
//      This is free software, and you are welcome to redistribute it
//      under certain conditions; type `show c' for details.
//
//  The hypothetical commands `show w' and `show c' should show the appropriate
//  parts of the General Public License.  Of course, your program's commands
//  might be different; for a GUI interface, you would use an "about box".
//
//    You should also get your employer (if you work as a programmer) or school,
//  if any, to sign a "copyright disclaimer" for the program, if necessary.
//  For more information on this, and how to apply and follow the GNU GPL, see
//  <http://www.gnu.org/licenses/>.
//
//    The GNU General Public License does not permit incorporating your program
//  into proprietary programs.  If your program is a subroutine library, you
//  may consider it more useful to permit linking proprietary applications with
//  the library.  If this is what you want to do, use the GNU Lesser General
//  Public License instead of this License.  But first, please read
//  <http://www.gnu.org/philosophy/why-not-lgpl.html>.
// ----------------------------------------------------------
** If you have questions regarding the use of this file, please contact
** yahia nouah (yahiaui@gmail.com)
** $elforkane_END_LICENSE$
**
****************************************************************************/
#ifndef MAINWINDOW_H
#define MAINWINDOW_H
#include <QtGui>
#include <QObject>
#include <QMainWindow>
#include "database.h"
//##include "scenfull.h"
#include <phonon/audiooutput.h>
//#include <phonon/backendcapabilities.h>
#include "fullinterface.h"
#include <phonon/mediaobject.h>
#include <phonon/seekslider.h>

#include <phonon/volumeslider.h>

class Pixmap : public QGraphicsWidget
{
    Q_OBJECT

public:
    Pixmap(const QPixmap &pix, QGraphicsItem *parent = 0)
        : QGraphicsWidget(parent), orig(pix), p(pix)
    {

        setCacheMode(DeviceCoordinateCache);
        setAcceptHoverEvents(true);
    }


    void paint(QPainter *painter, const QStyleOptionGraphicsItem *, QWidget *)
    {
        painter->drawPixmap(QPointF(), p);
    }

    virtual void setGeometry(const QRectF &rect)
    {
        QGraphicsWidget::setGeometry(rect);
   p = orig.scaled(rect.size().toSize());
//        if (rect.size().width() > orig.size().width())
//            p = orig.scaled(rect.size().toSize());
//        else
//            p = orig;
    }
    virtual void setPixmap(QPixmap pix)

    {

             orig=pix;
    }

signals:
    void pressed();
    void release();
    void enter();
    void leave();
 void mouseMove();

protected:

    void mousePressEvent(QGraphicsSceneMouseEvent *)
    {
        emit pressed();
        update();
    }
    void mouseReleaseEvent(QGraphicsSceneMouseEvent *)
    {
        emit release();
        update();
    }
    void hoverEnterEvent(  QGraphicsSceneHoverEvent *)
    {

        emit enter();
        update();

    }
    void hoverLeaveEvent ( QGraphicsSceneHoverEvent  *)
    {
        emit leave();
        update();
    }
        void mouseMoveEvent(QGraphicsSceneMouseEvent *)
        {
            emit mouseMove();
            update();
        }

private:
    QPixmap orig;
    QPixmap p;

};
namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

    Database *database;
    SceenFullInterface *sceenFullInterface;
public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    //slot for terminal
    void setSora(int sora);
    void setJozaa(int jozaa);
    void setHizb(int hizb);
    void setAya(int sora,int aya);
    void mediaPlay();//القراءة
    bool m_plaOne;
    void   fullScreen();
protected:
    void resizeEvent ( QResizeEvent *  );
 bool eventFilter(QObject *obj, QEvent *ev);
    void changeEvent(QEvent *e);
     virtual void closeEvent(QCloseEvent *e);
signals:

    void popupVisible(bool );

private slots:




    QPixmap disignePage(QString safha);
    //! [ انشاء ادوات البرنامج]
    void setupToolbarIcons();//انشاء الادوات
    void creatPagesAndPopup();               //انشاء الصفحات و ناقذة التفاسير والتراجم
    void creatMediaControles();  //انشاء لوحة ادوات الوسائط المتحركة
    void chargeDataTools();//تحميل البيانات على الادوات
    void menuTefsirAndTranslation();

    //systry
    void  createTrayIcon();
    void iconActivated(QSystemTrayIcon::ActivationReason reason);
    void showMessage();
    void setshowInfo(bool show);

    //! [setting]
    void loadSetting();
    void saveSetting();
    // void creatNavigation();
    //void openCloseNavigator(bool open);
    //  void closeNavigator();
    //  void animNavigatorFinished();

    //! [التنقل الى اماكن محددة]
    void setCurentPos(int pos);    //الانتقال الى الموضع المحدد
    //slot for spin
    void goAya();
    void goJozaa();
    void goHizb();
    void goPage();
    void goSura(int index);//الذهاب الى السورة المحددة


    void goAyaSelected();//الذهاب الى الاية المحددة عند النقر على الاية

    //! [animation]
    //لحركة التلقائية عند تغيير الصفحات
    void animPageRight();//تحريك الي لليمين
    void animPageLeft();//تحريك الي لليسار

    void moveSelection(int top,int hight,int x1,int x2); //تحريك التحديد الى الموضع الجديد
  void fullScreenPixmap(int top,int high,int x1,int x2);//استخراج نص الاية الحالية لوضعية ملء الشاشة
    void  moveMediaControle(); //تحريك لوحة ادوات الوسائط

    //go left to right عند سحب الصفحة الى اليمين
    void goNextEenter();//عند ادخال مؤشر الفأرة على الحافة اليسرى
    void goNextLeave();//عند خروج مؤشر الفأرة من الحافة اليسرى
    void goNextPrissed( );//عند نقر  مؤشر الفأرة على الحافة اليسرى
    void goNextMoved();//عند تحريك  مؤشر الفأرة من الحافة اليسرى
    void goNextRelease( );//عند ارسال  مؤشر الفأرة من الحافة اليسرى
    void moveLeftToRight();// تحريك الصفحة بواسطة مؤشر الفأرة نحوى اليمين

    // go right to left عند سحب الصفحة الى اليسار
    void goPrevEenter();//عند ادخال مؤشر الفأرة على الحافة اليمنى
    void goPrevLeave();//عند خروج مؤشر الفأرة من الحافة اليمنى
    void goPrevPrissed( );//عند نقر  مؤشر الفأرة على الحافة اليمنى
    void goPrevMoved();//عند تحريك  مؤشر الفأرة من الحافة اليمنى
    void goPrevRelease( );//عند ارسال  مؤشر الفأرة من الحافة اليمنى
    void moveRightToLeft();//تحريك الصفحة بواسطة مؤشر الفأرةنحوى اليسار

    //! [phonon]
    void stateChanged(Phonon::State newstate, Phonon::State oldstate); //تغير اوضاع القراءة
    void mediaFinished();//انتهاء القراءة
      //! [generale]
    void getOption(int tab,QString title);
    void locateThemePath();    //التحقق من مسارات الصور للسمة ان كانت موجودة
    QPixmap updatePixSelect(int h,int x1 ,int x2);//تحديث صورة التحديد وموضعه

    void updatPopup(qreal poY,qreal poX1,qreal poX2); //اعادة رسم وتحديث نافذة التراجم والتفاسير في الموضع المحدد-
    void hidePopup();
    void newPages();//رسم صفحات جديدة
    void convertTextToHtm(QString text);
    void chargeLastAndFirstAya();//معرفة اول واخر اية سواء في الصفحة او السورة
    void setSpinAyaMaximum(int index);
    void translationChanged();
    void tefsirChanged();
    void txtQuran();

    //! [actions]
    void on_actionNextPage_triggered();

    void on_actionPrevPage_triggered();

    void on_actionNextSura_triggered();

    void on_actionPrevSura_triggered();

    void on_actionNextAya_triggered();

    void on_actionPrevAya_triggered();

    void on_actionOptions_triggered();

    void on_actionFullScreen_triggered();

    void on_actionPlayPause_triggered();

    void on_actionStopMedia_triggered();

    void on_actionAddReceter_triggered();

    void on_actionRemoveReceter_triggered();//حذف المقرئ المحدد

    void on_actionAbout_triggered();

    void on_actionQuranText_triggered();

    void on_actionEditeReceter_triggered();

    void on_actionRceterEdite_triggered();

    void editReciter();//تحرير المقرئ

    void on_actionRepeatOption_triggered();

    //other tools

    void comboBoxResiter_activated(int index);

    void comboBoxSoraJozaa_currentIndexChanged(int index);

    void treeWidgetIndex_itemActivated(QTreeWidgetItem *item, int );

    void lineEditSearchTree_textChanged(const QString &arg1);

    void popup_toggled(bool checked);

    void on_graphicsView_customContextMenuRequested(const QPoint );

    void on_actionNavigation_toggled(bool arg1);



    void on_toolButtonGoSearch_clicked();



    void on_treeWidgetSearch_itemActivated(QTreeWidgetItem *item, int );

    void on_lineEditSearch_returnPressed();

    void on_lineEditSearchAnd_returnPressed();



    void on_actionEnableAnimFull_toggled(bool arg1);

    //void on_toolButton_clicked();

   // void on_pushButton_clicked();

private:
    Ui::MainWindow *ui;
   //   ScenFull *scenfull;
    // ادوات المشهد scen
    QPixmap m_pixRigtMoved;
    QPixmap m_pixLeftMoved;
    QGraphicsScene* m_scene;//المشهد
    QGraphicsPixmapItem *picMoved;
    Pixmap * itemRefletLeft;
    Pixmap * itemRefletRigt;
    Pixmap * btnLeft;    //زر على الصفحة اليسرى لسحب الصفحة
    Pixmap * btnRight;   //زر على الصفحة اليمنى لسحب الصفحة
    Pixmap * btnMedia;// زر عرض واخفاء لوحة ادوات الوسائط
    QGraphicsPixmapItem *pageLeft;//مربع الصفحة اليسرى
    QGraphicsPixmapItem *pageRight;//مربع الصفحة اليمنى
    Pixmap *itemSelection;  //مربع التحديد
    QGraphicsWidget  *panelParent ;
    QGraphicsWidget  *panelPopup ;
    QGraphicsWidget  *panelMedia;
    QGraphicsWidget  *panelNavig;
    QGraphicsPixmapItem *ItemPopup;
    QTextEdit *textEdit;
    QLabel *m_labMask;
    QList<Pixmap *> items;
    QLabel *labelTransTefsir;
    //متغيرات البرنامج
    bool m_animEnabled;
    bool m_bLeft;  //اذا كان التحريك لليسار مفعل
    bool m_bRight;  //اذا كان التحريك لليمين مفعل
    bool m_fitInView;
    bool m_showPopup;
    bool m_autoRepeatSura;
    bool m_autoRepeatPage;
    bool m_autoRepeatOne;
    bool m_autoRepeatFromTo;
    bool m_autoPlayNext;

    bool isPlay;//هل القراة تشتغل
    bool m_showInfo;//عرض المعلومات بجانب الساعة
    bool m_minimizToTry;//تصغير بجانب الساغة
    bool m_textIcon;
    bool m_isRepeatNumber;
    bool m_showMediaControl;
    bool isTefsirPopup;
    bool m_showMenu;
    bool m_showSelection;
    bool m_reciteBasmala;
    int m_id; //الموضع الحالي
    int m_sura; //رقم السورة الحالية
    int m_aya; //رقم الاية الحالية
    int m_jozaa; //رقم الجزء الحالي
    int m_hizb; //رقم الحزب الحالي
    int m_robaa; //رقم الربع الحالي
    int m_pHieght; //طول الصفحة
    int m_pWith;  //عرض الصفحة
    int m_curentSafhaLeft;  //الصفحة الحالية اليسرى
    int m_curentSafhaRight;  //الصفحة الحالية اليمنى
    int m_curentSafha;  //الصفحة الحالية المحددة
    int m_difer; //الفرق بين الصفحة اليسرة واليمنى عند تحريك الصفحة بواسطة المؤشر
    int m_px; // موضع الصور س
    int m_numPlayed; //   مرات القراءة حتى الان
    int m_repeatNumber; // عدد التكرار
    int m_receter; //المقرئ
    int m_repeatAyaFirst; //اول الاية في الصفحة او السورة
    int m_repeatAyaLast;//اخر الاية في الصفحة او السورة
    int m_infoDely;//مدة بقاء المعلومة في ايقونة النظام
    int m_curTranslation;// الترجمة الحالية
QString m_curentRiwaya;

    //---------------------------------
    bool m_fullAnimEnable;//تفعيل الحركة في وضع ملء الشاشة
// QString m_fullScreenBgr;
 bool m_fullAnimated;
 int m_fullIndex;
 void loadPlugin();
   QList<SceenFullInterface *>myListSceen;
    QList<QString > listSceenName;
//-----------------------------------
QList<QAction *>myListActionTrans;
    QString m_lng;//اللغة الحالية
    QString m_appPath;//مسار بينات البرنامج
    QString m_y;
    QString m_soundName;
    QString m_themeFolder;//مجلد السمة
    QString m_soundPath; //مسار الصوت الحالي
    QString m_soundUrl;//موقع الصوت الحالي
    QString m_layouDir;//اتجاه البرنامج
    QColor m_selectColor;//لون التحديد
    //Phonon
    QIcon playIcon;
    QIcon pauseIcon;
    Phonon::MediaObject m_MediaObject;

    Phonon::AudioOutput m_AudioOutput;
    Phonon::SeekSlider *slider;
    Phonon::VolumeSlider *volume;
    //------systry-----
    QSystemTrayIcon *trayIcon;
    QAction *actionMinimiz;
    QAction *actionRestore;
    QAction *actionSowInfo;

    //---------tool in toolbar
    QComboBox *comboSura;                               //القائمة المنسدلة للسور
    QSpinBox *spinAya;                                            //اداة ادخال رقم الاية
    QSpinBox *spinJozaa;                                            //اداة ادخال رقم الجزء
    QSpinBox *spinHizb;                                            //اداة ادخال رقم الحزب
    QSpinBox *spinSafha;                                            //اداة ادخال رقم الصفحة
    QAction *actTansTefsir;                                    //زر عرض قائمة التفاسير والتراجم
    // QComboBox *comboBoxSoraJozaa;
    //QLineEdit *lineEditSearchTree ;
    // QToolButton *toolButtonColaps ;
    //QToolButton *toolButtonExpand ;
    //QTreeWidget *treeWidgetIndex;
    QComboBox *comboBoxReciter;                //القائمة المنسدلة للمقرئين


};

#endif // MAINWINDOW_H
